/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 10.1.03 EDK_K_SP3.6
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    C:\xupv5_bsb_design\
 */


// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"

#include "stdio.h"

#include "xintc.h"
#include "intc_header.h"
#include "xuartns550_l.h"
#include "uartns550_header.h"
#include "xuartns550.h"
#include "xbasic_types.h"
#include "xgpio.h"
#include "xlltemac.h"
#include "xlltemac_example.h"
#include "lltemac_header.h"
#include "lltemac_intr_header.h"
#include "xlldma.h"
#include "uartlite_header.h"
#include "sleep.h"

#define HARD_RESET 1
#define SOFT_RESET 0

#define GMII_MODE 0
#define SGMII_MODE 1

#define LED_NORMAL  0x0000
#define LED_ON      0x0FFF
#define LED_OFF     0x0AAA
#define LED_BLINK   0x0555

#define PHY_INTERNAL_LOOPBACK 1
#define PHY_LOOPBACK_STUB 0

int PhyAddr;

extern unsigned char verbose;

extern XIntc Intc;

extern XLlTemac Hard_Ethernet_MAC_LlTemac;
extern XLlDma  Hard_Ethernet_MAC_LlDma;
extern XLlTemac_Config *MacCfgPtr;


//====================================================

int EthernetFrametest(TEMAC_SPEED){

   //static XIntc intc;
//   static XLlTemac Hard_Ethernet_MAC_LlTemac;
//   static XLlDma  Hard_Ethernet_MAC_LlDma;

//   static XTmrCtr xps_timer_1_Timer;

 XStatus Status;



Status = TemacSgDmaIntrExample(&Intc, &Hard_Ethernet_MAC_LlTemac,
                     &Hard_Ethernet_MAC_LlDma,
                     XPAR_HARD_ETHERNET_MAC_CHAN_0_DEVICE_ID,
                     XPAR_XPS_INTC_0_HARD_ETHERNET_MAC_TEMACINTC0_IRPT_INTR,
                     XPAR_LLTEMAC_0_LLINK_CONNECTED_DMARX_INTR,
                     XPAR_LLTEMAC_0_LLINK_CONNECTED_DMATX_INTR, TEMAC_SPEED);
return Status;
    
}


int Eth_Test (void) {


//   static XIntc intc;



   u16 PhyReg;
   
   u8 Rec=0;
   
   static XUartNs550 RS232_Uart_2_UartNs550;
   
   int Error_Code = 0;
   
int PhyLink [3];
//0: Link is up or down
//1: Link Duplex
//2: Link Speed
   
   int i;
   
   i=0;

   XStatus Status;

if (verbose)
{  
xil_printf("\r\n--------------------------------------------------------------------------");   
xil_printf("\r\nEthernet PHY GMII Mode Diagnostics");
xil_printf("\r\nCONNECT A LOOPBACK ETHERNET CONNECTOR TO THE BOARD");
xil_printf("\r\nSet the PHY hardware config to GMII mode: J22 and J23 between 1-2, J24 open");
xil_printf("\r\nPress any key to continue");
xil_printf("\r\n---------------------------------------------------------------------------\r\n\r\n");   

XUartNs550_RecvByte(XPAR_RS232_UART_0_BASEADDR);
}
    /*
     *  Initialize instance. Should be configured for SGDMA
     */
/*
    MacCfgPtr = XLlTemac_LookupConfig(XPAR_HARD_ETHERNET_MAC_CHAN_0_DEVICE_ID);
    Status = XLlTemac_CfgInitialize(&Hard_Ethernet_MAC_LlTemac, MacCfgPtr,
                    MacCfgPtr->BaseAddress);
    if (Status != XST_SUCCESS) {
        TemacUtilErrorTrap("Error in initialize");
        return XST_FAILURE;
    }
*/    

//Hardware Reset the PHY
	if (verbose) xil_printf ("\r\nHardware resetting the PHY");
    Status = ResetPhy (&Hard_Ethernet_MAC_LlTemac, HARD_RESET);    
    
//detect the PHY
    if (verbose) xil_printf ("\r\nDetecting PHY...");
    Status = DetectPhy (&Hard_Ethernet_MAC_LlTemac);

    if (Status != XTEST_PASSED) 
    {
        if (verbose)
        {
	        xil_printf ("\r\n**************************************************************************");
	        xil_printf ("\r\nERROR: Phy Was not Detected");
	        xil_printf ("\r\nCheck the MDIO and the MDC lines or the PHY device");
	        xil_printf ("\r\n**************************************************************************");
        }
        Error_Code = 0x01;
        return Error_Code;
    }
    

//Hardware Reset the PHY
	if (verbose) xil_printf ("\r\nHardware resetting the PHY");
    Status = ResetPhy (&Hard_Ethernet_MAC_LlTemac, HARD_RESET);
//	XLlTemac_Reset (&Hard_Ethernet_MAC_LlTemac, XTE_RESET_HARD);

//Read the PHY configuration mode
    if (verbose)
    {
	    xil_printf("\r\n------------------------------------------------------------------------");
	    xil_printf("\r\nChecking the initial hardware configuration of the PHY for GMII mode...");
	    xil_printf("\r\n------------------------------------------------------------------------\r\n");   
    }
	Status = CheckPhyInitialConfig (&Hard_Ethernet_MAC_LlTemac, GMII_MODE);
    if (Status) {
     		if (verbose)
     		{
             	 xil_printf("\r\n************************************************************");      
                 xil_printf("\r\nPHY Hardware Configuration FAILED");
                 xil_printf("\r\n************************************************************\r\n");
     		}
    Error_Code = 0x02;
    return Error_Code;
    }	
    else 
    {
    	if (verbose)
    	{
            xil_printf("\r\n************************************************************");
            xil_printf("\r\nPHY Hardware Configuration PASSED");
            xil_printf("\r\n************************************************************\r\n");
    	}
    }

//blinking the PHY LEDs
/*
    xil_printf("\r\n-------------------------------------------------------------------------------");
    xil_printf("\r\nBlinking the PHY LEDs, check the LEDs status then press any key to continue");
    xil_printf("\r\n-------------------------------------------------------------------------------\r\n");
    //Status = ManualSetPhyLeds(&Hard_Ethernet_MAC_LlTemac, LED_BLINK);
    //XUartNs550_RecvByte(XPAR_RS232_UART_0_BASEADDR);
*/
//Hardware Reset the PHY
//	if (verbose) xil_printf ("\r\nHardware resetting the PHY");
//    Status = ResetPhy (&Hard_Ethernet_MAC_LlTemac, HARD_RESET);
//	XLlTemac_Reset (&Hard_Ethernet_MAC_LlTemac, XTE_RESET_HARD);


//start Virtual Cable Test

/*    
    xil_printf("\r\n-------------------------------------------------------------------------------");    
    xil_printf("\r\nStarting Virtual Cable Test...");
    xil_printf("\r\n-------------------------------------------------------------------------------\r\n");
    
    Status = PhyVirtualCableTest (&Hard_Ethernet_MAC_LlTemac);
    if (Status==XST_SUCCESS) {
                               xil_printf("\r\n************************************************************");
                               xil_printf("\r\nVirtual Cable Test PASSED"); 
                               xil_printf("\r\n************************************************************\r\n");
    }
    else {                
                   xil_printf("\r\n************************************************************");
                   xil_printf("\r\nVirtual Cable Test FAILED");
                   xil_printf("\r\n************************************************************\r\n");
    }
*/    
//test autonegotiation in 1000T (gigabit) mode

/*
    xil_printf("\r\n-------------------------------------------------------------------------------");    
    xil_printf("\r\nStarting AutoNegotiation Test in 1000T Mode...");
    xil_printf("\r\nCONNECT A GIGABIT CAPABLE SWITCH TO THE BOARD");
    xil_printf("\r\n-------------------------------------------------------------------------------\r\n");
    while (!((Rec == 's') || (Rec == 'q'))){
        if (!((Rec == 's') || (Rec == 'q'))) xil_printf("\r\nPress s to continue the test, q to skip Autonegotiation Test in 1000T mode");
        Rec = XUartNs550_RecvByte(XPAR_RS232_UART_0_BASEADDR);
        if (Rec == 's'){
            xil_printf("\n\rRestarting autonegotiation...");
            Status = RestartPhyAutonegotiation (&Hard_Ethernet_MAC_LlTemac);
            if (Status) {
                xil_printf("\r\nPHY Autonegotiation TIMEOUT");
            }
            else {
                xil_printf ("\r\nReading Link Status...");
                Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
                if (Status == 2) xil_printf ("\r\nLink speed and Duplex not resolved: TIMEOUT");
                if (Status == 1) xil_printf ("\r\nERROR: Link speed and Duplex resolved but Link is DOWN");
                if (Status == 0) {
                        xil_printf ("\r\nLink is UP");
                        xil_printf ("\r\nSpeed is %d", PhyLink[1]);
                        if (PhyLink[2]) xil_printf("\r\nDuplex is FULL");
                        else xil_printf ("\r\nDuplex is HALF. WARNING! TEMAC cannot work in half duplex mode!");
                        if (PhyLink[1] == 1000) {
                                                  xil_printf("\r\n************************************************************");
                                                  xil_printf ("\r\nPHY 1000T mode autonegotiation PASSED");
                                                  xil_printf("\r\n************************************************************\r\n");
                        }
                        else {
                            xil_printf("\r\nERROR: Expected Speed: 1000, got %d", PhyLink[1]);
                            xil_printf("\r\nCheck if the network cable and the switch are capable of gigabit operation");   
                            xil_printf("\r\n************************************************************");
                            xil_printf ("\r\nPHY 1000T mode autonegotiation FAILED");
                            xil_printf("\r\n************************************************************\r\n");
                        }
                }
            }
        }
        else if (Rec == 'q') xil_printf("\r\nPHY 1000T mode autonegotiation test SKIPPED");
    }

Rec=0;
//test autonegotiation in 10/100 Mbps mode
    xil_printf("\r\n-------------------------------------------------------------------------------");    
    xil_printf("\r\nStarting AutoNegotiation Test in 10/100Mbps Mode...");
    xil_printf("\r\nCONNECT A 10/100Mbps CAPABLE SWITCH TO THE BOARD");
    xil_printf("\r\n-------------------------------------------------------------------------------");    
  
    while (!((Rec == 's') || (Rec == 'q'))){
        if (!((Rec == 's') || (Rec == 'q'))) xil_printf("\r\nPress s to continue, q to skip Autonegotiation Test in 10/100 mode");
        Rec = XUartNs550_RecvByte(XPAR_RS232_UART_0_BASEADDR);
        if (Rec == 's'){
            xil_printf("\n\rRestarting autonegotiation...");
            Status = RestartPhyAutonegotiation (&Hard_Ethernet_MAC_LlTemac);
            if (Status) {
                xil_printf("\r\nPHY Autonegotiation TIMEOUT");
            }
            else {
                xil_printf ("\r\nReading Link Status...");
                Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
                if (Status == 2) xil_printf ("\r\nLink speed and Duplex not resolved: TIMEOUT");
                if (Status == 1) xil_printf ("\r\nERROR: Link speed and Duplex resolved but Link is DOWN");
                if (Status == 0) {
                        xil_printf ("\r\nLink is UP");
                        xil_printf ("\r\nSpeed is %d", PhyLink[1]);
                        if (PhyLink[2]) xil_printf("\r\nDuplex is FULL");
                        else xil_printf ("\r\nDuplex is HALF. WARNING! TEMAC cannot work in half duplex mode!");
                        if ((PhyLink[1] == 10) ||
                            (PhyLink[1] == 100)) {
                                                    xil_printf("\r\n************************************************************");
                                                    xil_printf ("\r\nPHY 10/100Mbps mode autonegotiation PASSED");
                                                    xil_printf("\r\n************************************************************\r\n");
                            }
                        else {
                            xil_printf("\r\nERROR: Expected Speed: 10 or 100, got %d", PhyLink[1]);
                            xil_printf("\r\nCheck if the network cable and/or the switch are 10/100Mbps speed capable only");   
                            xil_printf("\r\n************************************************************");
                            xil_printf ("\r\nPHY 10/100 mode autonegotiation FAILED");
                            xil_printf("\r\n************************************************************");
                        }
                }
            }
        }
        else if (Rec == 'q') xil_printf("\r\nPHY 10/100 mode autonegotiation test SKIPPED");
    }
*/

/*
 Status = IntcInterruptSetup(&Intc, XPAR_XPS_INTC_0_DEVICE_ID);
       if (Status != 0) {
         print("Intc Interrupt Setup FAILED\r\n");
      } 
*/

//Test frame transmission with PHY in local loopback, 100Mbps mode


if (verbose)
{
	xil_printf("\r\n------------------------------------------------------------------------------------");    
	xil_printf("\r\n\r\nStarting Frame Transmission Test in 100Mbps Mode with internal PHY Loopback...");
	xil_printf("\r\n-------------------------------------------------------------------------------------\r\n");
}
Status = SetPhyLoopbackMode (&Hard_Ethernet_MAC_LlTemac, 100, PHY_INTERNAL_LOOPBACK);
Status = EthernetFrametest(100);
if (Status) {
		if (verbose)
		{
             xil_printf("\r\n*****************************************************************************");
             xil_printf("\r\nFrame Transmission Test in 100Mbps Mode with internal PHY Loopback FAILED");
             xil_printf("\r\n*****************************************************************************\r\n");
		}
    Error_Code = 0x03;
    return Error_Code;
}
else {
	if (verbose)
	{
        xil_printf("\r\n*****************************************************************************");
        xil_printf("\r\nFrame Transmission Test in 100Mbps Mode with internal PHY Loopback PASSED");
        xil_printf("\r\n*****************************************************************************\r\n");
	}
}

//Test frame transmission with PHY in local loopback, 1000Mbps mode
if (verbose)
{
	xil_printf("\r\n------------------------------------------------------------------------------------");    
	xil_printf("\r\n\r\nStarting Frame Transmission Test in 1000Mbps Mode with internal PHY Loopback...");
	xil_printf("\r\n------------------------------------------------------------------------------------\r\n");
}
    
Status = SetPhyLoopbackMode (&Hard_Ethernet_MAC_LlTemac, 1000, PHY_INTERNAL_LOOPBACK);
Status = EthernetFrametest(1000);
if (Status) {
	if (verbose)
	{
              xil_printf("\r\n*****************************************************************************");
              xil_printf("\r\nFrame Transmission Test in 1000Mbps Mode with internal PHY Loopback FAILED");
              xil_printf("\r\n*****************************************************************************\r\n");
	}
    Error_Code = 0x04;
    return Error_Code;
}
else 
{
	if (verbose)
	{
	    xil_printf("\r\n*****************************************************************************");
	    xil_printf("\r\n Frame Transmission Test in 1000Mbps Mode with internal PHY Loopback PASSED");
	    xil_printf("\r\n*****************************************************************************");
	}
}


usleep(50);
//Hardware Reset the PHY
   	if (verbose) xil_printf ("\r\nHardware resetting the PHY");
    Status = ResetPhy (&Hard_Ethernet_MAC_LlTemac, HARD_RESET);
//	XLlTemac_Reset (&Hard_Ethernet_MAC_LlTemac, XTE_RESET_HARD);

//Test frame transmission with PHY with stub connector, 100Mbps mode
if (verbose)
{
	xil_printf("\r\n------------------------------------------------------------------------------------");
	xil_printf("\r\nStarting Frame Transmission Test in 100Mbps Mode with PHY loopback stub...");
	xil_printf("\r\nCONNECT THE LOOPBACK CABLE TO THE BOARD");
	xil_printf("\r\nthen press any key to continue");
	xil_printf("\r\n------------------------------------------------------------------------------------\r\n");    
	XUartNs550_RecvByte(XPAR_RS232_UART_0_BASEADDR);
}
i=0;
Status = SetPhyLoopbackMode (&Hard_Ethernet_MAC_LlTemac, 100, PHY_LOOPBACK_STUB);
Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
while (Status){
     Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
      i++;
      usleep(10);
      if ((i==5000) || (Status == 2)) {
                    if (verbose) xil_printf("\r\nERROR: Link is DOWN");
	                if (verbose) xil_printf("\r\nPlease check if the loopback cable is properly inserted in the plug");
                    Error_Code = 0x05;
				    return Error_Code;
                    break;
                   }
      if (!(Status)){
         if (verbose) xil_printf ("\r\nLink is UP");
         if (verbose) xil_printf ("\r\nSpeed is %d", PhyLink[1]);
         if (verbose)
         {
	         if (PhyLink[2]) xil_printf("\r\nDuplex is FULL");
	         else xil_printf ("\r\nDuplex is HALF. WARNING! TEMAC cannot work in half duplex mode!");
         }
      }
}        

Status = EthernetFrametest(100);
if (Status){
	if (verbose)
	{
	     xil_printf("\r\n*****************************************************************************");
	     xil_printf("\r\n Frame Transmission Test in 100Mbps Mode with PHY loopback stub FAILED");
	     xil_printf("\r\n*****************************************************************************\r\n");
	}
     Error_Code = 0x06;
     return Error_Code;
}
else {
	if (verbose)
	{
	    xil_printf("\r\n*****************************************************************************");
	    xil_printf("\r\n Frame Transmission Test in 100Mbps Mode with PHY loopback stub PASSED");
	    xil_printf("\r\n*****************************************************************************\r\n");
	}
}


usleep(50);
//Hardware Reset the PHY
   	if (verbose) xil_printf ("\r\nHardware resetting the PHY");
    Status = ResetPhy (&Hard_Ethernet_MAC_LlTemac, HARD_RESET);
//	XLlTemac_Reset (&Hard_Ethernet_MAC_LlTemac, XTE_RESET_HARD);

//Test frame transmission with PHY with stub connector, 1000Mbps mode
if (verbose)
{
	xil_printf("\r\n------------------------------------------------------------------------------------");
	xil_printf("\r\nStarting Frame Transmission Test in 1000Mbps Mode with PHY loopback stub...");
	xil_printf("\r\n------------------------------------------------------------------------------------\r\n");    
}

i=0;
Status = SetPhyLoopbackMode (&Hard_Ethernet_MAC_LlTemac, 1000, PHY_LOOPBACK_STUB);

Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
while (Status){
     Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
      i++;
      usleep(10);
      if ((i==5000) || (Status == 2)) {
                    if (verbose) xil_printf("\r\nERROR: Link is DOWN");
                    if (verbose) xil_printf("\r\nPlease check if the loopback cable is properly inserted in the plug");
                    Error_Code = 0x07;
				    return Error_Code;
                    break;
                   }
      if (!(Status))
      {
         if (verbose) xil_printf ("\r\nLink is UP");
         if (verbose) xil_printf ("\r\nSpeed is %d", PhyLink[1]);
         if (verbose)
         {
         	 if (PhyLink[2]) xil_printf("\r\nDuplex is FULL");
         	 else xil_printf ("\r\nDuplex is HALF. WARNING! TEMAC cannot work in half duplex mode!");
         }
      }
}        

Status = EthernetFrametest(1000);
if (Status) {
	 if (verbose)
	 {
            xil_printf("\r\n*****************************************************************************");
            xil_printf("\r\n Frame Transmission Test in 1000Mbps Mode with PHY loopback stub FAILED");
            xil_printf("\r\n*****************************************************************************\r\n");
	 }
     Error_Code = 0x08;
     return Error_Code;
}
else {
	if (verbose)
	{
        xil_printf("\r\n*****************************************************************************");
        xil_printf("\r\n Frame Transmission Test in 1000Mbps Mode with PHY loopback stub PASSED");
        xil_printf("\r\n*****************************************************************************\r\n");
	}
}

//usleep(50000);
//Hardware Reset the PHY
//   	if (verbose) xil_printf ("\r\nHardware resetting the PHY");
//    Status = ResetPhy (&Hard_Ethernet_MAC_LlTemac, HARD_RESET);
//	XLlTemac_Reset (&Hard_Ethernet_MAC_LlTemac, XTE_RESET_HARD);

/*
//Test frame transmission with PHY with stub connector, 10Mbps mode
xil_printf("\r\n------------------------------------------------------------------------------------");
xil_printf("\r\nStarting Frame Transmission Test in 10Mbps Mode with PHY loopback stub...");
xil_printf("\r\n------------------------------------------------------------------------------------\r\n");

i=0;
Status = SetPhyLoopbackMode (&Hard_Ethernet_MAC_LlTemac, 10, PHY_LOOPBACK_STUB);
Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
while (Status){
     Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
     if (Status == 2) break;
     if (!(Status)){
         xil_printf ("\r\nLink is UP");
         xil_printf ("\r\nSpeed is %d", PhyLink[1]);
         if (PhyLink[2]) xil_printf("\r\nDuplex is FULL");
         else xil_printf ("\r\nDuplex is HALF. WARNING! TEMAC cannot work in half duplex mode!");
      }
}        

Status = EthernetFrametest(10);
if (Status){
            xil_printf("\r\n*****************************************************************************");
            xil_printf("\r\n Frame Transmission Test in 10Mbps Mode with PHY loopback stub FAILED");
            xil_printf("\r\n*****************************************************************************\r\n");
}
else {
    xil_printf("\r\n*****************************************************************************");
    xil_printf("\r\n Frame Transmission Test in 10Mbps Mode with PHY loopback stub PASSED");
    xil_printf("\r\n*****************************************************************************\r\n");
}

xil_printf("\r\n*****************************************************************************");
xil_printf("\r\nEnd of Ethernet Diagnosis in GMII Mode");
xil_printf("\r\n*****************************************************************************\r\n");

*/

   return 0;
}

int Eth_Autonegotiation_Test (void) {


//   static XIntc intc;



   u16 PhyReg;
   
   u8 Rec=0;
   
   static XUartNs550 RS232_Uart_2_UartNs550;
   
   int Error_Code = 0;
   
int PhyLink [3];
//0: Link is up or down
//1: Link Duplex
//2: Link Speed
   
   int i;
   
   i=0;

   XStatus Status;

//Hardware Reset the PHY
	if (verbose) xil_printf ("\r\nHardware resetting the PHY");
    Status = ResetPhy (&Hard_Ethernet_MAC_LlTemac, HARD_RESET);    
    
    
//test autonegotiation in 1000T (gigabit) mode

if (verbose)
   {
    xil_printf("\r\n-------------------------------------------------------------------------------");    
    xil_printf("\r\nStarting AutoNegotiation Test in 1000T Mode...");
    xil_printf("\r\nCONNECT A GIGABIT CAPABLE SWITCH TO THE BOARD");
    xil_printf("\r\nAnd press any key to continue");
    xil_printf("\r\n-------------------------------------------------------------------------------\r\n");
    Rec = XUartNs550_RecvByte(XPAR_RS232_UART_0_BASEADDR);
   }

    if (verbose) xil_printf("\n\rRestarting autonegotiation...");
    
    Status = RestartPhyAutonegotiation (&Hard_Ethernet_MAC_LlTemac);
    if (Status) 
    {
        if (verbose) xil_printf("\r\nPHY Autonegotiation TIMEOUT");
        Error_Code = 0x01;
        return Error_Code;
    }
    else 
    {
        if (verbose) xil_printf ("\r\nReading Link Status...");
        Status = GetPhyLinkStatus (&Hard_Ethernet_MAC_LlTemac, PhyLink);
        if (Status == 2)
        {
         if (verbose) xil_printf ("\r\nLink speed and Duplex not resolved: TIMEOUT");
         Error_Code = 0x01;
         return Error_Code;
        } 
        if (Status == 1)
        {
        	if (verbose) xil_printf ("\r\nERROR: Link speed and Duplex resolved but Link is DOWN");
        	Error_Code = 0x02;
            return Error_Code;
        }
        if (Status == 0) 
        {
        	if (verbose) xil_printf ("\r\nLink is UP");
            if (verbose) xil_printf ("\r\nSpeed is %d", PhyLink[1]);
            if (PhyLink[2])
           {
               if (verbose) xil_printf("\r\nDuplex is FULL");
           }
           else if (verbose)xil_printf ("\r\nDuplex is HALF. WARNING! TEMAC cannot work in half duplex mode!");
           if (PhyLink[1] == 1000) 
           {
           		if (verbose)
           		{
                     xil_printf("\r\n************************************************************");
                     xil_printf ("\r\nPHY 1000T mode autonegotiation PASSED");
                     xil_printf("\r\n************************************************************\r\n");
                 }
           }   
           else 
           {
                if (verbose)
                {
                     xil_printf("\r\nERROR: Expected Speed: 1000, got %d", PhyLink[1]);
                     xil_printf("\r\nCheck if the network cable and the switch are capable of gigabit operation");   
                     xil_printf("\r\n************************************************************");
                     xil_printf ("\r\nPHY 1000T mode autonegotiation FAILED");
                     xil_printf("\r\n************************************************************\r\n");
                 }
            	Error_Code = PhyLink[1];
         		return Error_Code;
            }
        }
    }

   return 0;
}


