/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * 
 *
 * This file is a generated sample test application.
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * SDK application project when you run the "Generate Libraries" menu item.
 *
 */


#include <stdio.h>
#include "xparameters.h"
#include "xenv_standalone.h"
#include "xio.h"
#include "xbasic_types.h"




#include "sleep.h"

extern unsigned char verbose;

void Unlock_Flash_Block (Xuint32 FLASH_BASEADDR, Xuint32 BLOCK_ADDRESS){
	
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0x60);//lock block setup
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0xD0);//unlock block
}

int Erase_Flash_Block (Xuint32 FLASH_BASEADDR, Xuint32 BLOCK_ADDRESS){
Xuint16 Flash_Data;


//unlock the block first
	XIo_Out16 (FLASH_BASEADDR, 0xFF);
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0x60);//lock block setup
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0xD0);//unlock block

	
	XIo_Out16 (FLASH_BASEADDR, 0xFF);
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0x20);//erase block
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0xD0);//erase block confirm
	XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
	Flash_Data = XIo_In16(FLASH_BASEADDR);
	
	while (!(Flash_Data&0x80)){
		Flash_Data = XIo_In16(FLASH_BASEADDR);
		//xil_printf("\r\n0x%X", FLASH_DATA);	
	}
	
	if (Flash_Data & 0x20){
		 //if (verbose) xil_printf ("\r\nBlock Erase Error, Block Address = 0x%X, Status = 0x%X", BLOCK_ADDRESS,  Flash_Data);
		 XIo_Out16 (FLASH_BASEADDR, 0x50);//Clear Status Register
		 return XTEST_FAILED;
	}
	XIo_Out16 (FLASH_BASEADDR, 0x50);//Clear Status Register
	return XTEST_PASSED;
	
	//if (verbose) xil_printf ("\r\nErase Successful, Status = 0x%X", Flash_Data);
}

int Blank_Check_Flash_Block (Xuint32 FLASH_BASEADDR, Xuint32 BLOCK_ADDRESS){
Xuint16 Flash_Data;

//unlock the block first
	XIo_Out16 (FLASH_BASEADDR, 0xFF);
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0x60);//lock block setup
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0xD0);//unlock block

	
	XIo_Out16 (FLASH_BASEADDR, 0xFF);
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0xBC);//blank check
	XIo_Out16 (FLASH_BASEADDR+BLOCK_ADDRESS, 0xD0);//erase block confirm
	XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
	Flash_Data = XIo_In16(FLASH_BASEADDR);
	
	while (!(Flash_Data&0x80)){
		Flash_Data = XIo_In16(FLASH_BASEADDR);
		//xil_printf("\r\n0x%X", FLASH_DATA);	
	}
	
	if (Flash_Data & 0x20){
		 //if (verbose) xil_printf ("\r\nBlank Check Error, Block is not blank, Address = 0x%X, Status = 0x%X", BLOCK_ADDRESS,  Flash_Data);
	     XIo_Out16 (FLASH_BASEADDR, 0x50);//Clear Status Register
		 return XTEST_FAILED;
	}
	
	XIo_Out16 (FLASH_BASEADDR, 0x50);//Clear Status Register
	return XTEST_PASSED;
	
	//if (verbose) xil_printf ("\r\nBlock is blank, Address = 0x%X, Status = 0x%X", BLOCK_ADDRESS,  Flash_Data);
}


int Program_Flash_Word (Xuint32 FLASH_BASEADDR, Xuint32 FLASH_ADDRESS, Xuint16 FLASH_DATA){
u16 Status;

//unlock the block first
	XIo_Out16 (FLASH_BASEADDR, 0xFF);
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, 0x60);//lock block setup
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, 0xD0);//unlock block
	
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, 0x40);//word program
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, FLASH_DATA);//data to program
	XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
	Status = XIo_In16(FLASH_BASEADDR+0x00);
		
	while (!(Status & 0x80)) Status = XIo_In16(FLASH_BASEADDR+0x00);

	if (Status & 0x10){
		 //if (verbose) xil_printf ("\r\nWord Program Error, Address = 0x%X, Status = 0x%X", FLASH_ADDRESS,  Status);
		 XIo_Out16 (FLASH_BASEADDR, 0x50);//Clear Status Register
		 return XTEST_FAILED;
	}
	
	XIo_Out16 (FLASH_BASEADDR, 0x50);//Clear Status Register
	return XTEST_PASSED;	
}

int Program_Flash_Buffer (Xuint32 FLASH_BASEADDR, Xuint32 FLASH_ADDRESS, 
						  Xuint32 MEM_ADDR, Xuint32 NUM_BYTES){
u16 Status;
u16 FLASH_DATA;
u16 NUM_WORDS;
Xuint32 i;

	

	if (NUM_BYTES &0x01)
	{
	if (verbose) xil_printf ("\r\nProgram Error, Integer number of words required, got 0x%X/2", NUM_BYTES);
	 return XTEST_FAILED;		
	}
	if (NUM_BYTES > 1024)
	{
	if (verbose) xil_printf ("\r\nProgram Error, Number of Words = 0x%X is larger than 512", (NUM_BYTES/2));
	 return XTEST_FAILED;
	}

	NUM_WORDS = NUM_BYTES/2;
	
//unlock the block first
	XIo_Out16 (FLASH_BASEADDR, 0xFF);
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, 0x60);//lock block setup
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, 0xD0);//unlock block
	
//setup buffered program
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, 0xE8);//Buffered program
//wait until the buffer is ready
	Status = XIo_In16(FLASH_BASEADDR+FLASH_ADDRESS);	
	while (!(Status & 0x80)) Status = XIo_In16(FLASH_BASEADDR+FLASH_ADDRESS);
	//if (verbose) xil_printf ("\r\nFLASH memory status before buffer write 0x%X", Status);
//write the word count
	//if (verbose) xil_printf ("\r\nWriting to the FLASH memory, Address 0x%X, Number of Words 0x%X", FLASH_BASEADDR+FLASH_ADDRESS, NUM_WORDS);
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, (NUM_WORDS-1));
//write the data into the buffer
	for (i=0; i<NUM_BYTES; i=i+2)
	{
		FLASH_DATA	= XIo_In16 (MEM_ADDR + i);
		//if (verbose) xil_printf ("\r\nWriting to the FLASH memory, Address 0x%X, Number 0x%X, Data 0x%X", (FLASH_ADDRESS + i), (i/2), FLASH_DATA);
		XIo_Out16 (FLASH_BASEADDR + FLASH_ADDRESS + i, FLASH_DATA);	
	}
//write the Buffered Program Confirm command
	XIo_Out16 (FLASH_BASEADDR+FLASH_ADDRESS, 0xD0);//Buffered program confirm

	XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
	Status = XIo_In16(FLASH_BASEADDR+0x00);
		
	while (!(Status & 0x80)) Status = XIo_In16(FLASH_BASEADDR+0x00);

	if (Status & 0x30){
		 if (verbose) xil_printf ("\r\nBuffer Program Error, Address = 0x%X, Status = 0x%X", FLASH_BASEADDR+FLASH_ADDRESS,  Status);
		 XIo_Out16 (FLASH_BASEADDR, 0x50);//Clear Status Register
		 return XTEST_FAILED;
	}
	if (verbose) xil_printf ("\r\nBuffer Program Succeeded, Address = 0x%X, Status = 0x%X", FLASH_BASEADDR+FLASH_ADDRESS,  Status);
	XIo_Out16 (FLASH_BASEADDR, 0x50);//Clear Status Register
	return XTEST_PASSED;	
}

int Program_Flash_Data (Xuint32 FLASH_BASEADDR, Xuint32 FLASH_ADDRESS, 
						  Xuint32 MEM_ADDR, Xuint32 DATA_SIZE_BYTES){
u16 Status;
u16 FLASH_DATA;
Xuint32 i, j;
Xuint32 NUM_BLOCKS;
Xuint32 err = 0;
Xuint32 Failed_Address = 0;

	i = 0;
	err = 0;
	
	
	
	NUM_BLOCKS = DATA_SIZE_BYTES / 1024;
	if (DATA_SIZE_BYTES <= 1024)
	{
		if (verbose) xil_printf ("\r\nBuffer programming FLASH Address 0x%X, Data size 0x%X", FLASH_ADDRESS, DATA_SIZE_BYTES);
		if (Program_Flash_Buffer (FLASH_BASEADDR, FLASH_ADDRESS, MEM_ADDR, DATA_SIZE_BYTES))
		{
			err++;
			if (verbose) xil_printf ("\r\nBuffer Program Error, Address = 0x%X, Data Size = 0x%X", FLASH_ADDRESS,  DATA_SIZE_BYTES);
			Failed_Address = FLASH_ADDRESS;
			if (!(Failed_Address)) return 0xFFFFFE;
			else return Failed_Address;
		}
	}
	else
	{
		while (i < DATA_SIZE_BYTES)
		{
			if (verbose) xil_printf ("\r\nBuffer programming FLASH Address 0x%X, Data size 0x%X", FLASH_ADDRESS + i, 512);
			if (Program_Flash_Buffer (FLASH_BASEADDR, FLASH_ADDRESS + i, MEM_ADDR + i, 1024))
			{
				err++;
				if (verbose) xil_printf ("\r\nBuffer Program Error, Address = 0x%X, Data size = 0x%X", FLASH_ADDRESS + i,  DATA_SIZE_BYTES);
				Failed_Address = FLASH_ADDRESS + i ;
				if (!(Failed_Address)) return 0xFFFFFE;
				else return Failed_Address;
			}
			i = i + 1024;
		}
		i = i - 1024;
		j = DATA_SIZE_BYTES - i;
		if (verbose) xil_printf ("\r\nBuffer programming FLASH Address 0x%X, Data size 0x%X", FLASH_ADDRESS + i, j);
		if (Program_Flash_Buffer (FLASH_BASEADDR, FLASH_ADDRESS + i, MEM_ADDR + i, j))
			{
				err++;
				if (verbose) xil_printf ("\r\nBuffer Program Error, Address = 0x%X, Data size = 0x%X", FLASH_ADDRESS + i,  j);
				Failed_Address = FLASH_ADDRESS + i ;
				return Failed_Address;
			}
	}
	return XTEST_PASSED;	
}

int StrataFlash_Presence(Xuint32 FLASH_BASEADDR) 
{
Xuint8 temp;


  XIo_Out16(FLASH_BASEADDR, 0x90); //read device ID
  //Read Query mode
  temp = XIo_In16(FLASH_BASEADDR+0x00);
  if (verbose) xil_printf("\r\nIdcode = 0x%x", temp);
  //temp = XIo_In16(FLASH_BASEADDR+0x21);
  //if (verbose) xil_printf("Idcode = %x", temp);
  
  if(temp == 0x89)//check if the device ID is 0x89
  	return  XTEST_PASSED;
	else
	{
		if (verbose) xil_printf ("\r\nFlash Memory is not present");
		return XTEST_FAILED;
	}

}


Xuint32 StrataFlash_test(unsigned int FLASH_BASEADDR, unsigned int FLASH_HIGHADDR){

Xuint32 FLASH_SIZE; //determines the memory size
Xuint32 ADDRESS_LINES; //determines the address lines needed to walk
Xuint32 i, j;
Xuint32 FLASH_ADDR;
Xuint16 FLASH_DATA_WR, FLASH_DATA_RD;
Xuint16 Flash_Data;
Xuint32 err=0;

Xuint32 Failed_Address = 0;

//16-bit access will be used, so divide with two the FLASH size
FLASH_SIZE=(FLASH_HIGHADDR-FLASH_BASEADDR+1)/2;

ADDRESS_LINES=0;
FLASH_ADDR=0;
while (FLASH_ADDR<FLASH_SIZE)
{
   FLASH_ADDR = 1 << ADDRESS_LINES;
   ADDRESS_LINES++;
}

ADDRESS_LINES--; //decrement with one to obtain 
                 //the correct number of address lines

 if (verbose) xil_printf("\r\nFLASH size = 0x%X, ADDRESS LINES = %d", FLASH_SIZE, ADDRESS_LINES);



if ((StrataFlash_Presence(FLASH_BASEADDR)))
   {
     if (verbose) xil_printf ("\r\nFLASH memory is not present");
      return 0xFFFFFFFF;
   }

if (verbose) xil_printf ("\r\nErasing Flash...");


//Erase the first four 16-kbyte blocks
for (i=0; i<0x10000; i=i+0x4000)
{
	if (verbose) xil_printf ("\r\nErasing Flash block 0x%X", i);

	if (Blank_Check_Flash_Block (FLASH_BASEADDR, i))
	{	
		if (Erase_Flash_Block (FLASH_BASEADDR, i))
		{
			err++;
			XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
			Flash_Data = XIo_In16(FLASH_BASEADDR);
			if (verbose) xil_printf ("\r\nBlock Erase Error, Block Address = 0x%X, Status = 0x%X", i,  Flash_Data);
			Failed_Address = i;
			return Failed_Address;
		}
	}
	else if (verbose) xil_printf ("\r\nBlock 0x%X is blank, it will not be erased", i);
}

//Erase the next 254 64-kbyte blocks
for (i=0x10000; i<(FLASH_SIZE - 0x10000); i=i+0x10000)
{
	if (verbose) xil_printf ("\r\nErasing Flash block 0x%X", i);
	if (Blank_Check_Flash_Block (FLASH_BASEADDR, i))
	{
		if (Erase_Flash_Block (FLASH_BASEADDR, i))
		{
			err++;
			XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
			Flash_Data = XIo_In16(FLASH_BASEADDR);
			if (verbose) xil_printf ("\r\nBlock Erase Error, Block Address = 0x%X, Status = 0x%X", i,  Flash_Data);
			Failed_Address = i;
			return Failed_Address;
		}
	}
	else if (verbose) xil_printf ("\r\nBlock 0x%X is blank, it will not be erased", i);
}

//Erase the last four 16-kbyte blocks
for (i=(FLASH_SIZE - 0x10000); i<FLASH_SIZE; i=i+0x4000)
{
	if (verbose) xil_printf ("\r\nErasing Flash block 0x%X", i);
	if (Blank_Check_Flash_Block (FLASH_BASEADDR, i))
	{
		if (Erase_Flash_Block (FLASH_BASEADDR, i))
		{
			err++;
			XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
			Flash_Data = XIo_In16(FLASH_BASEADDR);
			if (verbose) xil_printf ("\r\nBlock Erase Error, Block Address = 0x%X, Status = 0x%X", i,  Flash_Data);
			Failed_Address = i;
			return Failed_Address;
		}
	}
	else if (verbose) xil_printf ("\r\nBlock 0x%X is blank, it will not be erased", i);
}


if (verbose) xil_printf ("\r\nFlash Erase completed");
//reset FLASH to read array mode
XIo_Out16 (FLASH_BASEADDR, 0xFF);

//check if the FLASH is blank at the first address
Flash_Data  = XIo_In16 (FLASH_BASEADDR);
if (verbose) xil_printf("\r\nBlank Test at address 0x%06.6X, data 0x%04.4X", 0x000000, Flash_Data);
if (Flash_Data != 0xFFFF)
	{
		err++;
		if (verbose) xil_printf ("\r\nFlash Blank Test Error, Address = 0x%X, Expected 0xFFFF, got 0x%X", i,  Flash_Data);
		Failed_Address =  FLASH_BASEADDR;
		return Failed_Address;
	}

//Blank test FLASH memory

//Blank check the first four 16-kbyte blocks
for (i=0; i<0x10000; i=i+0x4000)
{
	if (verbose) xil_printf ("\r\nBlank Checking Flash block 0x%X", i);

	Flash_Data  = Blank_Check_Flash_Block (FLASH_BASEADDR, i);
	if (Flash_Data)
	{	
			err++;
			if (verbose) xil_printf ("\r\nBlank Check Error, Block is not blank, Address = 0x%X, Status = 0x%X", i,  Flash_Data);
			Failed_Address = i;
			return Failed_Address;
	}
}

//Blank check the next 254 64-kbyte blocks
for (i=0x10000; i<(FLASH_SIZE - 0x10000); i=i+0x10000)
{
	if (verbose) xil_printf ("\r\nBlank Checking Flash block 0x%X", i);
	Flash_Data  = Blank_Check_Flash_Block (FLASH_BASEADDR, i);
	if (Flash_Data)
	{	
			err++;
			if (verbose) xil_printf ("\r\nBlank Check Error, Block is not blank, Address = 0x%X, Status = 0x%X", i,  Flash_Data);
			Failed_Address = i;
			return Failed_Address;
	}
}

//Blank check the last four 16-kbyte blocks
for (i=(FLASH_SIZE - 0x10000); i<FLASH_SIZE; i=i+0x4000)
{
	if (verbose) xil_printf ("\r\nBlank Checking Flash block 0x%X", i);
	Flash_Data  = Blank_Check_Flash_Block (FLASH_BASEADDR, i);
	if (Flash_Data)
	{	
			err++;
			if (verbose) xil_printf ("\r\nBlank Check Error, Block is not blank, Address = 0x%X, Status = 0x%X", i,  Flash_Data);
			Failed_Address = i;
			return Failed_Address;
	}
}



/*
for (i=0; i<FLASH_SIZE; i=i+2)
{
	FLASH_ADDR = FLASH_BASEADDR + i;
	Flash_Data  = XIo_In16 (FLASH_ADDR);
	if ((i&0xFFFFF)==0){
		if (verbose) xil_printf("\r\nBlank Test at address 0x%06.6X, data 0x%04.4X", i, Flash_Data);
	}
	if (Flash_Data != 0xFFFF)
	{
		err++;
		if (verbose) xil_printf ("\r\nFlash Blank Test Error, Address = 0x%X, Expected 0xFFFF, got 0x%X", i,  Flash_Data);
		Failed_Address =  i;
		return Failed_Address;
	}
}
*/
if (verbose) xil_printf ("\r\nFlash Erase successfull");

/********************************************************************************
 * Walk 0, walk 1 test
********************************************************************************/
/*
//program FLASH
//walk 1 on the address lines, 0 on the data lines
for (i=0 ; i<16; i=i+1)
	{
      FLASH_ADDR = (1<<i);
      FLASH_DATA_WR = (0xFFFF <<(i+1))|(0xFFFF >> (16-i));
//      XIo_Out32(MEM_ADDR, MEM_DATA_WR);
      if (verbose) xil_printf("\r\nProgramming Address 0x%06.6X, Data 0x%04.4X", (1<<i), FLASH_DATA_WR);
	  if  (Program_Flash_Word (FLASH_BASEADDR, FLASH_ADDR, FLASH_DATA_WR))
	  {
	  	err++;
		XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
		Flash_Data = XIo_In16(FLASH_BASEADDR);
		if (verbose) xil_printf ("\r\nFlash Program Error, Address = 0x%X, Status = 0x%X", (1<<i),  Flash_Data);
		Failed_Address =  (1<<i);
		return Failed_Address;
	  }
	}

//walk 1 on both the remaining address and data lines
for (i=16 ; i<=24; i=i+1)
	{
      FLASH_ADDR = (1<<i);
      FLASH_DATA_WR = (1 <<(i-15));
//      XIo_Out32(MEM_ADDR, MEM_DATA_WR);
      if (verbose) xil_printf("\r\nProgramming Address 0x%06.6X, Data 0x%04.4X", (1<<i), FLASH_DATA_WR);
	  if  (Program_Flash_Word (FLASH_BASEADDR, FLASH_ADDR, FLASH_DATA_WR))
	  {
	  	err++;
		XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
		Flash_Data = XIo_In16(FLASH_BASEADDR);
		if (verbose) xil_printf ("\r\nFlash Program Error, Address = 0x%X, Status = 0x%X", (1<<i),  Flash_Data);
		Failed_Address =  (1<<i);
		return Failed_Address;
	  }
	}

//program HIGHADDR with 0x0000
      if (verbose) xil_printf("\r\nProgramming Address 0x%06.6X, Data 0x%04.4X", ((FLASH_SIZE*2)-2), 0x0000);
	  if  (Program_Flash_Word (FLASH_BASEADDR, ((FLASH_SIZE*2)-2), 0x0000))
	  {
	  	err++;
		XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
		Flash_Data = XIo_In16(FLASH_BASEADDR);
		if (verbose) xil_printf ("\r\nFlash Program Error, Address = 0x%X, Status = 0x%X", ((FLASH_SIZE*2)-2),  Flash_Data);
		Failed_Address =  ((FLASH_SIZE*2)-2);
		return Failed_Address;
	  }

//reset FLASH to read array mode
XIo_Out16 (FLASH_BASEADDR, 0xFF);
//Check programming for walk 0
for (i=0 ; i<16; i=i+1)
	{
      FLASH_ADDR = FLASH_BASEADDR + (1<<i);
      FLASH_DATA_WR = (0xFFFF <<(i+1))|(0xFFFF >> (16-i));
	  FLASH_DATA_RD = XIo_In16(FLASH_ADDR);
      if (verbose) xil_printf("\r\nReading Address 0x%06.6X, Data 0x%04.4X", (1<<i), FLASH_DATA_RD);
	  if  (FLASH_DATA_RD != FLASH_DATA_WR)
	  {
	  	err++;
		XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
		Flash_Data = XIo_In16(FLASH_BASEADDR);
		if (verbose) xil_printf ("\r\nFlash Program Error, Address = 0x%06.6X, Expected 0x%04.4X, got 0x%04.4X", (1<<i), FLASH_DATA_WR, FLASH_DATA_RD);
		Failed_Address =  FLASH_ADDR;
		//return Failed_Address;
	  }
	}

//check programming for walk 1
for (i=16 ; i<=24; i=i+1)
	{
      FLASH_ADDR = FLASH_BASEADDR + (1<<i);
      FLASH_DATA_WR = (1 <<(i-15));
 	  FLASH_DATA_RD = XIo_In16(FLASH_ADDR);
      if (verbose) xil_printf("\r\nReading Address 0x%06.6X, Data 0x%04.4X", (1<<i), FLASH_DATA_RD);
	  if  (FLASH_DATA_RD != FLASH_DATA_WR)
	  {
	  	err++;
		XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
		Flash_Data = XIo_In16(FLASH_BASEADDR);
		if (verbose) xil_printf ("\r\nFlash Program Error, Address = 0x%06.6X, Expected 0x%04.4X, got 0x%04.4X", (1<<i), FLASH_DATA_WR, FLASH_DATA_RD);
		Failed_Address =  FLASH_ADDR;
		//return Failed_Address;
	  }
	}

//check the programming of HIGHADDR
 	  FLASH_DATA_RD = XIo_In16(FLASH_BASEADDR + ((FLASH_SIZE*2)-2));
      if (verbose) xil_printf("\r\nReading Address 0x%06.6X, Data 0x%04.4X", ((FLASH_SIZE*2)-2), FLASH_DATA_RD);
	  if  (FLASH_DATA_RD)
	  {
	  	err++;
		XIo_Out16 (FLASH_BASEADDR, 0x70);//read status register
		Flash_Data = XIo_In16(FLASH_BASEADDR);
		if (verbose) xil_printf ("\r\nFlash Program Error, Address = 0x%06.6X, Expected 0x%04.4X, got 0x%04.4X", ((FLASH_SIZE*2)-2),  FLASH_DATA_WR, FLASH_DATA_RD);
		Failed_Address =  ((FLASH_SIZE*2)-2);
		//return Failed_Address;
	  }
*/
return  XTEST_PASSED;	
}

/*

int main() 
{

Xuint32 Usb_epp_data;
Xuint32 Usb_epp_address;
Xuint32 Usb_epp_status;

XStatus Status;

//Xuint16 FLASH_DATA;
//Xuint32 FLASH_DATA_32;
Xuint32 FLASH_ADDRESS;
u8 FLASH_DATA_8;
u8 b0, b1, b2, b3;
Xuint32 data_size = 0;

u8 Send_Data, Rec_Data;

Xuint32 i = 0;

   static XIntc Intc;
*/
   /* Initialize xps_uart16550_0 - Set baudrate and number of stop bits */
/*
   XUartNs550_SetBaud(UART_0_BASEADDR, XPAR_XUARTNS550_CLOCK_HZ, 9600);
   XUartNs550_mSetLineControlReg(UART_0_BASEADDR, XUN_LCR_8_DATA_BITS);

   XCACHE_ENABLE_ICACHE();
   XCACHE_ENABLE_DCACHE();

   print("---Entering main---\n\r");

   Status = XIntc_Initialize (&Intc, XPAR_XPS_INTC_0_DEVICE_ID);
   if (Status != XST_SUCCESS) xil_printf ("\r\nInterrupt controller initialization failure");
   else xil_printf("\r\nInterrupt controller initialized");
   
   Status = XIntc_Connect (&Intc, XPAR_XPS_INTC_0_USB_EPP_IF_0_EPP_IRPT_INTR,
                             (XInterruptHandler) usb_epp_interrupt_handler,
                             (void *)XPAR_USB_EPP_IF_0_BASEADDR);
  if (Status != XST_SUCCESS) xil_printf ("\r\nRegistering USB_EPP Interupt Failed");
  else xil_printf("\r\nUSB_EPP Interrupt registerred");

   XIntc_Enable  (&Intc, XPAR_XPS_INTC_0_USB_EPP_IF_0_EPP_IRPT_INTR); 
   
   
   Status = XIntc_Start(&Intc, XIN_REAL_MODE);
  if (Status != XST_SUCCESS) xil_printf ("\r\nInterupt controller starting failed");
  else xil_printf("\r\nInterrupt controller started");
  
  microblaze_enable_interrupts();
  
  XIo_Out16 (FLASH_BASEADDR, 0xFF);//Read array
*/

 /*
  for (i=0; i<0x100; i++){
  	FLASH_DATA_8 = XIo_In8 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR + i);
  	xil_printf ("\r\nFlash data at address 0x%X is 0x%X", i, FLASH_DATA_8);
  	
  	
  }
*/

/*
	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, 0xFF);//Read array
	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, 0x98);//Enter CFI mode
	FLASH_DATA = XIo_In16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR + 0x0010);
	xil_printf ("\r\nData at address 0x0010 is 0x%X", FLASH_DATA);
	
	FLASH_DATA = XIo_In16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR + 0x0012);
	xil_printf ("\r\nData at address 0x0011 is 0x%X", FLASH_DATA);
	
	FLASH_DATA = XIo_In8 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR + 0x0014);
	xil_printf ("\r\nData at address 0x0012 is 0x%X", FLASH_DATA);
*/



/*
  
 //unlock all blocks
	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, 0x60);//lock block setup
	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, 0xD0);//unlock block

	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR+0x4000, 0x60);//lock block setup
	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR+0x4000, 0xD0);//unlock block
	
	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR+0x8000, 0x60);//lock block setup
	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR+0x8000, 0xD0);//unlock block

	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR+0xC000, 0x60);//lock block setup
	XIo_Out16 (XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR+0xC000, 0xD0);//unlock block

	for (i=1; i<0x100; i++){
		FLASH_ADDRESS = i << 16;
		xil_printf("\r\nUnlocking address 0x%X", FLASH_ADDRESS);
		Unlock_Flash_Block(XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, FLASH_ADDRESS);
	}
	
	xil_printf("\r\nFlash blocks unlocked");
	xil_printf("\r\nErasing...");
	if ((Erase_Flash_Block(XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, 0x00))== XST_FAILURE) return 1;
	
	if ((Erase_Flash_Block(XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, 0x4000))== XST_FAILURE) return 1;
	
	if ((Erase_Flash_Block(XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, 0x8000))== XST_FAILURE) return 1;

	if ((Erase_Flash_Block(XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, 0xC000))== XST_FAILURE) return 1;

	for (i=1; i<0x100; i++){
		FLASH_ADDRESS = i << 16;
		xil_printf("\r\nErasing block 0x%X", i);
		if ((Erase_Flash_Block(XPAR_XPS_MCH_EMC_0_MEM0_BASEADDR, FLASH_ADDRESS))== XST_FAILURE) return 1;
	}
	
	xil_printf("\r\nErasing complete");
	
		xil_printf("\r\nReceiving and programming data");
	
	Current_Addr = 0;
  	i=0;
    FLASH_DATA = 0x0000;

*/

/* 
	while (1);


	Usb_epp_status = XIo_In32(XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_STATUS_REG_OFFSET);
	while (!(Usb_epp_status & USB_EPP_STATUS_WRITE_PERFORMED)){
		Usb_epp_status = XIo_In32(XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_STATUS_REG_OFFSET);
	}

	Usb_epp_address = Usb_epp_status & 0x000000FF;
	XIo_Out32(XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_ADDRESS_REG_OFFSET, Usb_epp_address);
	Usb_epp_data = XIo_In32(XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_DATA_REG_OFFSET);
	
	xil_printf("\r\nDigilent USB write performed, Status = 0x%0.8X, Data = 0x%X", Usb_epp_status, Usb_epp_data); 


   print("---Exiting main---\n\r");

   XCACHE_DISABLE_ICACHE();
   XCACHE_DISABLE_DCACHE();

   return 0;
}

*/
