
/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 10.1.02 EDK_K_SP2.5
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    D:\Home\Albert\Digilent\Projects\Xupv5\ML505_bsb_project\
 */


// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"

#include "stdio.h"

#include "xuartns550_l.h"
#include "xutil.h"
#include "xgpio.h"
#include "xgpio_l.h"
#include "xio.h"
#include "sleep.h"
#include "lcd.h"
#include "xbasic_types.h"
#include "xlltemac.h"
#include "ac97_if_00.h"

#define LED_NORMAL  0x0
#define LED_ON      0x3
#define LED_OFF     0x2
#define LED_BLINK   0x1


//====================================================

extern unsigned char dip, dip_pre; //used to determine the status of the DIP switches
extern unsigned char push, push_pre; //used to determine the status of the pushbuttons
                               //bit 0 - center button
                               //bit 1 - left button
                               //bit 2 - down button
                               //bit 3 - right button
                               //bit 4 - up button
                               //bit 5 - BTN1 button
                               //bit 6 - BTN0 button

extern unsigned char gpio_devices[15]; //shows the status of the GPIO devices, 
//0 - unchanged, 1 - pressed or on, 2 - released or off
//0 to 7 - DIP switches, 8-14 - push buttons

extern XLlTemac Hard_Ethernet_MAC_LlTemac;
extern int PhyAddr;

extern XGpio DIP8, Push7, LED8;
extern XGpio Pmod_Conn, VHDCI_1_Conn, VHDCI_2_Conn, PS2_Conn;
XStatus Status;

extern unsigned char verbose;

//====================================================


void Gpio_devices_initialize()
{
Status = XGpio_Initialize(&DIP8, XPAR_DIP_SWITCHES_8BIT_DEVICE_ID);
Status = XGpio_Initialize(&Push7, XPAR_PUSH_BUTTONS_7BIT_DEVICE_ID);
Status = XGpio_Initialize(&LED8, XPAR_LEDS_8BIT_DEVICE_ID);
Status = XGpio_Initialize(&Pmod_Conn, XPAR_PMOD_CONN_DEVICE_ID);
Status = XGpio_Initialize(&VHDCI_1_Conn, XPAR_VHDCI_1_CONN_DEVICE_ID);
Status = XGpio_Initialize(&VHDCI_2_Conn, XPAR_VHDCI_2_CONN_DEVICE_ID);
Status = XGpio_Initialize(&PS2_Conn, XPAR_PS2_CONN_DEVICE_ID);

Status = DetectPhy (&Hard_Ethernet_MAC_LlTemac);


XGpio_SetDataDirection(&LED8, 1, 0x0);

dip = XGpio_DiscreteRead(&DIP8, 1);
dip_pre=dip;
push = XGpio_DiscreteRead(&Push7, 1);
push_pre=push;

XGpio_DiscreteWrite(&LED8, 1, dip);


}

Xuint32 Pmod_Conn_short_test(XGpio Pmod_Conn)
{

//Bit 31 represents JA1
//Bit 30 represents JA2
//Bit 29 represents JA3
//Bit 28 represents JA4
//Bit 27 represents JA7
//Bit 26 represents JA8
//Bit 25 represents JA9
//Bit 24 represents JA10

//Bit 23 represents JB1
//Bit 22 represents JB2
//Bit 21 represents JB3
//Bit 20 represents JB4
//Bit 19 represents JB7
//Bit 18 represents JB8
//Bit 17 represents JB9
//Bit 16 represents JB10

//Bit 15 represents JC1
//Bit 14 represents JC2
//Bit 13 represents JC3
//Bit 12 represents JC4
//Bit 11 represents JC7
//Bit 10 represents JC8
//Bit 9 represents JC9
//Bit 8 represents JC10

//Bit 7 represents JD1
//Bit 6 represents JD2
//Bit 5 represents JD3
//Bit 4 represents JD4
//Bit 3 represents JD7
//Bit 2 represents JD8
//Bit 1 represents JD9
//Bit 0 represents JD10


  Xuint32 Write_Data, Read_Data=0;
  Xuint32 temp;
  char i, err;
  Xuint32 Error_Code = 0x00000000;

  err=0;
 //walk 0 test

 for (i=0; i<=32; i++)
	{

		if (i==32)
		{
		 Write_Data = 0xFFFFFFFF;
		}
		else 
		{
			Write_Data = 0xFFFFFFFF ^ (1 << i);
		}
		XGpio_SetDataDirection(&Pmod_Conn, 1, Write_Data);
		XGpio_DiscreteWrite(&Pmod_Conn, 1, Write_Data);

		if (verbose) xil_printf ("\r\nWriting to connector 0x%08.8X", Write_Data);
      
     usleep(100);
		Read_Data = XGpio_DiscreteRead(&Pmod_Conn, 1);
	
		if (verbose) xil_printf ("\r\nReading from connector 0x%X", Read_Data);

		if (!(Read_Data==Write_Data)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x%X, got 0x%X", Write_Data, Read_Data);
			Error_Code = Error_Code | (Read_Data ^ Write_Data);
			//return Error_Code;
         }
	}

	if (!(err)) return XTEST_PASSED;
	else return Error_Code;
//   return XTEST_PASSED;
}

Xuint32 Pmod_Conn_loopback_test(XGpio Pmod_Conn)
{

  Xuint32 Write_Data, Read_Data=0;
  Xuint32 temp;
  Xuint32 i, j;
  Xuint32 err;
  Xuint32 Error_Code = 0x00000000;

  err=0;
  
 //walk 1 test on the lower lines

 for (i=0; i<4; i++)
	{
		Write_Data = 0x01010101 << i;

		XGpio_SetDataDirection(&Pmod_Conn, 1, 0xF0F0F0F0);
		XGpio_DiscreteWrite(&Pmod_Conn, 1, Write_Data);

		if (verbose) xil_printf ("\r\nWriting to connector 0x%08.8X", Write_Data);
      
        usleep(100);
		Read_Data = XGpio_DiscreteRead(&Pmod_Conn, 1);
	
		if (verbose) xil_printf ("\r\nReading from connector 0x%X", Read_Data);

		if (!((Read_Data & 0xF0F0F0F0)== (Write_Data << 4 ))) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x%X, got 0x%X", (Write_Data <<4), (Read_Data & 0xF0F0F0F0));
			Error_Code = Error_Code | ((Read_Data & 0xF0F0F0F0) ^ (Write_Data << 4)) ;
			//return Error_Code;
         }
	}

//walk 1 test on the upper lines

 for (i=0; i<4; i++)
	{
		Write_Data = 0x10101010 << i;

		XGpio_SetDataDirection(&Pmod_Conn, 1, 0x0F0F0F0F);
		XGpio_DiscreteWrite(&Pmod_Conn, 1, Write_Data);

		if (verbose) xil_printf ("\r\nWriting to connector 0x%08.8X", Write_Data);
      
        usleep(100);
		Read_Data = XGpio_DiscreteRead(&Pmod_Conn, 1);
	
		if (verbose) xil_printf ("\r\nReading from connector 0x%X", Read_Data);

		if (!((Read_Data & 0x0F0F0F0F)== (Write_Data >> 4 ))) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x%X, got 0x%X", (Write_Data >> 4), (Read_Data & 0x0F0F0F0F));
			Error_Code = Error_Code | ((Read_Data & 0x0F0F0F0F) ^ (Write_Data >> 4)) ;
			//return Error_Code;
         }
	}


	if (!(err)) return XTEST_PASSED;
	else return Error_Code;
//   return XTEST_PASSED;
}


Xuint32 Vhdci_Conn_short_test(XGpio VHDCI_1_Conn, XGpio VHDCI_2_Conn)
{
//VHDCI 1, EXP-IO1 to EXP-IO20
//Channnel 1 connects to P signals, Channel 2 to N signals
//Channel 1 Bit 0   corresponds to EXP-IO1_P,   Channel 2 Bit 0    corresponds to EXP-IO1_N   
//Channel 1 Bit 1   corresponds to EXP-IO2_P,   Channel 2 Bit 1    corresponds to EXP-IO2_N   
//Channel 1 Bit 2   corresponds to EXP-IO3_P,   Channel 2 Bit 2    corresponds to EXP-IO3_N   
//Channel 1 Bit 3   corresponds to EXP-IO4_P,   Channel 2 Bit 3    corresponds to EXP-IO4_N   
//Channel 1 Bit 4   corresponds to EXP-IO5_P,   Channel 2 Bit 4    corresponds to EXP-IO5_N   
//Channel 1 Bit 5   corresponds to EXP-IO6_P,   Channel 2 Bit 5    corresponds to EXP-IO6_N   
//Channel 1 Bit 6   corresponds to EXP-IO7_P,   Channel 2 Bit 6    corresponds to EXP-IO7_N   
//Channel 1 Bit 7   corresponds to EXP-IO8_P,   Channel 2 Bit 7    corresponds to EXP-IO8_N   
//Channel 1 Bit 8   corresponds to EXP-IO9_P,   Channel 2 Bit 8    corresponds to EXP-IO9_N   
//Channel 1 Bit 9   corresponds to EXP-IO10_P,  Channel 2 Bit 9    corresponds to EXP-IO10_N 
//Channel 1 Bit 10 corresponds to EXP-IO11_P,  Channel 2 Bit 10  corresponds to EXP-IO11_N   
//Channel 1 Bit 11 corresponds to EXP-IO12_P,  Channel 2 Bit 11  corresponds to EXP-IO12_N  
//Channel 1 Bit 12 corresponds to EXP-IO13_P,  Channel 2 Bit 12  corresponds to EXP-IO13_N  
//Channel 1 Bit 13 corresponds to EXP-IO14_P,  Channel 2 Bit 13  corresponds to EXP-IO14_N  
//Channel 1 Bit 14 corresponds to EXP-IO15_P,  Channel 2 Bit 14  corresponds to EXP-IO15_N  
//Channel 1 Bit 15 corresponds to EXP-IO16_P,  Channel 2 Bit 15  corresponds to EXP-IO16_N  
//Channel 1 Bit 16 corresponds to EXP-IO17_P,  Channel 2 Bit 16  corresponds to EXP-IO17_N  
//Channel 1 Bit 17 corresponds to EXP-IO18_P,  Channel 2 Bit 17  corresponds to EXP-IO18_N  
//Channel 1 Bit 18 corresponds to EXP-IO19_P,  Channel 2 Bit 18  corresponds to EXP-IO19_N  
//Channel 1 Bit 19 corresponds to EXP-IO20_P,  Channel 2 Bit 19  corresponds to EXP-IO20_N  

//VHDCI 2, EXP-IO21 to EXP-IO40
//Channnel 1 connects to P signals, Channel 2 to N signals
//Channel 1 Bit 0  corresponds to EXP-IO21_P,  Channel 2 Bit 0  corresponds to EXP-IO21_N
//Channel 1 Bit 1  corresponds to EXP-IO22_P,  Channel 2 Bit 1  corresponds to EXP-IO22_N
//Channel 1 Bit 2  corresponds to EXP-IO23_P,  Channel 2 Bit 2  corresponds to EXP-IO23_N
//Channel 1 Bit 3  corresponds to EXP-IO24_P,  Channel 2 Bit 3  corresponds to EXP-IO24_N
//Channel 1 Bit 4  corresponds to EXP-IO25_P,  Channel 2 Bit 4  corresponds to EXP-IO25_N
//Channel 1 Bit 5  corresponds to EXP-IO26_P,  Channel 2 Bit 5  corresponds to EXP-IO26_N
//Channel 1 Bit 6  corresponds to EXP-IO27_P,  Channel 2 Bit 6  corresponds to EXP-IO27_N
//Channel 1 Bit 7  corresponds to EXP-IO28_P,  Channel 2 Bit 7  corresponds to EXP-IO28_N
//Channel 1 Bit 8  corresponds to EXP-IO29_P,  Channel 2 Bit 8  corresponds to EXP-IO29_N
//Channel 1 Bit 9  corresponds to EXP-IO30_P,  Channel 2 Bit 9  corresponds to EXP-IO30_N
//Channel 1 Bit 10 corresponds to EXP-IO31_P,  Channel 2 Bit 10 corresponds to EXP-IO31_N
//Channel 1 Bit 11 corresponds to EXP-IO32_P,  Channel 2 Bit 11 corresponds to EXP-IO32_N
//Channel 1 Bit 12 corresponds to EXP-IO33_P,  Channel 2 Bit 12 corresponds to EXP-IO33_N
//Channel 1 Bit 13 corresponds to EXP-IO34_P,  Channel 2 Bit 13 corresponds to EXP-IO34_N
//Channel 1 Bit 14 corresponds to EXP-IO35_P,  Channel 2 Bit 14 corresponds to EXP-IO35_N
//Channel 1 Bit 15 corresponds to EXP-IO36_P,  Channel 2 Bit 15 corresponds to EXP-IO36_N
//Channel 1 Bit 16 corresponds to EXP-IO37_P,  Channel 2 Bit 16 corresponds to EXP-IO37_N
//Channel 1 Bit 17 corresponds to EXP-IO38_P,  Channel 2 Bit 17 corresponds to EXP-IO38_N
//Channel 1 Bit 18 corresponds to EXP-IO39_P,  Channel 2 Bit 18 corresponds to EXP-IO39_N
//Channel 1 Bit 19 corresponds to EXP-IO40_P,  Channel 2 Bit 19 corresponds to EXP-IO40_N

//Write_Data[0] and Read_Data[0] - VHDCI 1 channel 1
//Write_Data[1] and Read_Data[1] - VHDCI 1 channel 2
//Write_Data[2] and Read_Data[2] - VHDCI 2 channel 1
//Write_Data[3] and Read_Data[3] - VHDCI 2 channel 2
  Xuint32 Write_Data[4];
  Xuint32 Read_Data[4];
  Xuint32 temp;
  Xuint32 i, j, k;
  Xuint32 err;
  Xuint32 Error_Code;

  err=0;
  
  Error_Code = 0;

 //walk 0 on VHDCI 1 channel 1, then channel 2, then VHDCI 2 channel 1 then channel 2

for (i=0; i<4; i++)
{ 
 	for (k=0; k<4; k++)
 		Write_Data[k] = 0xFFFFFFFF;
 	
 	for (j=0; j<20; j++)
 	{
		
		Write_Data[i] = 0xFFFFFFFF ^ (1 << j);

		XGpio_SetDataDirection(&VHDCI_1_Conn, 1, Write_Data[0]);
		XGpio_SetDataDirection(&VHDCI_1_Conn, 2, Write_Data[1]);
		XGpio_SetDataDirection(&VHDCI_2_Conn, 1, Write_Data[2]);
		XGpio_SetDataDirection(&VHDCI_2_Conn, 2, Write_Data[3]);
		
		XGpio_DiscreteWrite(&VHDCI_1_Conn, 1, Write_Data[0]);
		XGpio_DiscreteWrite(&VHDCI_1_Conn, 2, Write_Data[1]);
		XGpio_DiscreteWrite(&VHDCI_2_Conn, 1, Write_Data[2]);
		XGpio_DiscreteWrite(&VHDCI_2_Conn, 2, Write_Data[3]);

		//mask the data written
		for (k=0; k<4; k++)
		{
	 		Write_Data[k] = Write_Data[k] & 0x000FFFFF;
		}
		if (verbose) xil_printf ("\r\nWriting to connector VHDCI 1 0x%08.8X, 0x%08.8X, VHDCI 2 0x%08.8X, 0x%08.8X", Write_Data[0], Write_Data[1], Write_Data[2], Write_Data[3]);
      
     	usleep(100);
		Read_Data[0] = XGpio_DiscreteRead(&VHDCI_1_Conn, 1);
		Read_Data[1] = XGpio_DiscreteRead(&VHDCI_1_Conn, 2);
		Read_Data[2] = XGpio_DiscreteRead(&VHDCI_2_Conn, 1);
		Read_Data[3] = XGpio_DiscreteRead(&VHDCI_2_Conn, 2);
	
		//mask the data read
		for (k=0; k<4; k++)
		{
			Read_Data[k] = Read_Data[k] & 0x000FFFFF;
		}
	
		if (verbose) xil_printf ("\r\nReading from connector VHDCI 1 0x%08.8X, 0x%08.8X, VHDCI 2 0x%08.8X, 0x%08.8X", Read_Data[0], Read_Data[1], Read_Data[2], Read_Data[3]);

		for (k=0; k<4; k++)
		{
			if (!(Read_Data[k]==Write_Data[k])) 
    	    {
	            err++;
            	if (verbose) xil_printf("\r\nError, expected VHDCI %d Channel %d 0x%08.8X, got 0x%08.8X, Bit number %d", (((k&0x02)>>1)+1),((k&0x01)+1), Write_Data[k], Read_Data[k], j);
				Error_Code = (Error_Code &(~(0x000000FF << ( k * 8)))) | ((j & 0x000000FF) << ( k * 8));
				if (verbose) xil_printf("\r\nError Code is 0x%08.8X", Error_Code);
    	    }
		}
	}		
}
//test if any pin is shorted to ground
	for (k=0; k<4; k++)
 		Write_Data[k] = 0xFFFFFFFF;
 		
		XGpio_SetDataDirection(&VHDCI_1_Conn, 1, Write_Data[0]);
		XGpio_SetDataDirection(&VHDCI_1_Conn, 2, Write_Data[1]);
		XGpio_SetDataDirection(&VHDCI_2_Conn, 1, Write_Data[2]);
		XGpio_SetDataDirection(&VHDCI_2_Conn, 2, Write_Data[3]);
		
		XGpio_DiscreteWrite(&VHDCI_1_Conn, 1, Write_Data[0]);
		XGpio_DiscreteWrite(&VHDCI_1_Conn, 2, Write_Data[1]);
		XGpio_DiscreteWrite(&VHDCI_2_Conn, 1, Write_Data[2]);
		XGpio_DiscreteWrite(&VHDCI_2_Conn, 2, Write_Data[3]);

for (k=0; k<4; k++)
		{
	 		Write_Data[k] = Write_Data[k] & 0x000FFFFF;
		}
		if (verbose) xil_printf ("\r\nWriting to connector VHDCI 1 0x%08.8X, 0x%08.8X, VHDCI 2 0x%08.8X, 0x%08.8X", Write_Data[0], Write_Data[1], Write_Data[2], Write_Data[3]);
      
     	usleep(100);
		Read_Data[0] = XGpio_DiscreteRead(&VHDCI_1_Conn, 1);
		Read_Data[1] = XGpio_DiscreteRead(&VHDCI_1_Conn, 2);
		Read_Data[2] = XGpio_DiscreteRead(&VHDCI_2_Conn, 1);
		Read_Data[3] = XGpio_DiscreteRead(&VHDCI_2_Conn, 2);
	
		for (k=0; k<4; k++)
		{
			Read_Data[k] = Read_Data[k] & 0x000FFFFF;
		}
	
		if (verbose) xil_printf ("\r\nReading from connector VHDCI 1 0x%08.8X, 0x%08.8X, VHDCI 2 0x%08.8X, 0x%08.8X", Read_Data[0], Read_Data[1], Read_Data[2], Read_Data[3]);

		for (k=0; k<4; k++)
		{
			if (!(Read_Data[k]==Write_Data[k])) 
    	    {
	            err++;
            	if (verbose) xil_printf("\r\nError, expected VHDCI %d Channel %d 0x%08.8X, got 0x%08.8X, Bit number %d", (((k&0x02)>>1)+1),((k&0x01)+1), Write_Data[k], Read_Data[k], j);
				for (j=0; j<19; j++)
				{
					if (!((Read_Data[k]) & (1 << j)))
						Error_Code = (Error_Code &(~(0x000000FF << ( k * 8)))) | ((j & 0x000000FF) << ( k * 8));
				}
				if (verbose) xil_printf("\r\nError Code is 0x%08.8X", Error_Code);
    	    }
		}

	if (!(err)) return XTEST_PASSED;
	else return Error_Code;
}

Xuint32 Vhdci_Conn_loopback_test(XGpio VHDCI_1_Conn, XGpio VHDCI_2_Conn)
{
  Xuint32 Write_Data[2];
  Xuint32 Read_Data[2];

  Xuint32 temp;
  Xuint32 i, j, k;
  Xuint32 err;
  Xuint32 Error_Code;

  err=0;
  
  Error_Code = 0;

//walk 1 on VHDCI 1 channel 1, then channel 2

for (i=0; i<2; i++)
{ 
 	for (j=0; j<20; j++)
 	{
		
		Write_Data[i] = (1 << j);
	
		//set to 0 the other channel
		Write_Data[1-i] = 0;		

		XGpio_SetDataDirection(&VHDCI_1_Conn, 1, 0x00000000);
		XGpio_SetDataDirection(&VHDCI_1_Conn, 2, 0x00000000);
		XGpio_SetDataDirection(&VHDCI_2_Conn, 1, 0xFFFFFFFF);
		XGpio_SetDataDirection(&VHDCI_2_Conn, 2, 0xFFFFFFFF);
		
		XGpio_DiscreteWrite(&VHDCI_1_Conn, 1, Write_Data[0]);
		XGpio_DiscreteWrite(&VHDCI_1_Conn, 2, Write_Data[1]);

		//mask the data written
		for (k=0; k<2; k++)
		{
	 		Write_Data[k] = Write_Data[k] & 0x000FFFFF;
		}
		if (verbose) xil_printf ("\r\nWriting to connector VHDCI 1 0x%08.8X, 0x%08.8X", Write_Data[0], Write_Data[1]);
      
     	usleep(100);
		Read_Data[0] = XGpio_DiscreteRead(&VHDCI_2_Conn, 1);
		Read_Data[1] = XGpio_DiscreteRead(&VHDCI_2_Conn, 2);
	
		//mask the data read
		for (k=0; k<2; k++)
		{
			Read_Data[k] = Read_Data[k] & 0x000FFFFF;
		}
	
		if (verbose) xil_printf ("\r\nReading from connector VHDCI 2 0x%08.8X, 0x%08.8X", Read_Data[0], Read_Data[1]);

		if (!(Read_Data[i]==Write_Data[i])) 
    	    {
	            err++;
            	if (verbose) xil_printf("\r\nError, expected VHDCI 2 Channel %d 0x%08.8X, got 0x%08.8X, Bit number %d", (i+1), Write_Data[i], Read_Data[i], j);
				temp = Read_Data[i] & Write_Data[i]; //lines are in pullup
				for (k=0; k<20; k++)
				{
					if (temp & (1 << k)) 
					{
						Error_Code = (Error_Code & (~(0x000000FF << (8*i))))  | (k << (8*i));
						break;
					}
				}
				if (verbose) xil_printf("\r\nError Code is 0x%08.8X", Error_Code);
    	    }
	}		
}

//walk 1 on VHDCI 2 channel 1, then channel 2

for (i=0; i<2; i++)
{ 
 	for (j=0; j<20; j++)
 	{
		
		Write_Data[i] = (1 << j);
	
		//set to 0 the other channel
		Write_Data[1-i] = 0;		

		XGpio_SetDataDirection(&VHDCI_1_Conn, 1, 0xFFFFFFFF);
		XGpio_SetDataDirection(&VHDCI_1_Conn, 2, 0xFFFFFFFF);
		XGpio_SetDataDirection(&VHDCI_2_Conn, 1, 0x00000000);
		XGpio_SetDataDirection(&VHDCI_2_Conn, 2, 0x00000000);
		
		XGpio_DiscreteWrite(&VHDCI_2_Conn, 1, Write_Data[0]);
		XGpio_DiscreteWrite(&VHDCI_2_Conn, 2, Write_Data[1]);

		//mask the data written
		for (k=0; k<2; k++)
		{
	 		Write_Data[k] = Write_Data[k] & 0x000FFFFF;
		}
		if (verbose) xil_printf ("\r\nWriting to connector VHDCI 2 0x%08.8X, 0x%08.8X", Write_Data[0], Write_Data[1]);
      
     	usleep(100);
		Read_Data[0] = XGpio_DiscreteRead(&VHDCI_1_Conn, 1);
		Read_Data[1] = XGpio_DiscreteRead(&VHDCI_1_Conn, 2);
	
		//mask the data read
		for (k=0; k<2; k++)
		{
			Read_Data[k] = Read_Data[k] & 0x000FFFFF;
		}
	
		if (verbose) xil_printf ("\r\nReading from connector VHDCI 1 0x%08.8X, 0x%08.8X", Read_Data[0], Read_Data[1]);

		if (!(Read_Data[i]==Write_Data[i])) 
    	    {
	            err++;
            	if (verbose) xil_printf("\r\nError, expected VHDCI 1 Channel %d 0x%08.8X, got 0x%08.8X, Bit number %d", (i+1), Write_Data[i], Read_Data[i], j);
				temp = Read_Data[i] & Write_Data[i];//lines are in pullup
				for (k=0; k<20; k++)
				{
					if (temp & (1 << k))
					{
						Error_Code = (Error_Code & (~(0x000000FF << ((8*i)+16))))  | (k << ((8*i)+16));
						break;
					}
				}
				if (verbose) xil_printf("\r\nError Code is 0x%08.8X", Error_Code);
    	    }
	}		
}

	if (!(err)) return XTEST_PASSED;
	else if (!(Error_Code)) return 0xFFFFFFFE;
	else return Error_Code;
}

Xuint32 PS2_short_test(XGpio PS2_Conn)
{
 Xuint32 Read_Data=0;
  Xuint32 temp;
  char i, err;
  Xuint32 Error_Code = 0;

  err=0;
  
  //write 01, expect 01
  XGpio_SetDataDirection(&PS2_Conn, 1, 0x01);
  XGpio_DiscreteWrite(&PS2_Conn, 1, 0x1);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x01");

  Read_Data=XGpio_DiscreteRead(&PS2_Conn, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x01)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x01, got 0x%X", Read_Data);
         	Error_Code = 0x010100 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
  //write 10, expect 11
  XGpio_DiscreteWrite(&PS2_Conn, 1, 0x2);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x2");

  Read_Data=XGpio_DiscreteRead(&PS2_Conn, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x3)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x3, got 0x%X", Read_Data);
         	Error_Code = 0x010300 | (Read_Data & 0x03);
         	return Error_Code;
         }    
  
  //write 00, expect 01
  XGpio_DiscreteWrite(&PS2_Conn, 1, 0x0);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x00");

  Read_Data=XGpio_DiscreteRead(&PS2_Conn, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x01)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x1, got 0x%X", Read_Data);
         	Error_Code = 0x010100 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
  //write 11, expect 11
  XGpio_DiscreteWrite(&PS2_Conn, 1, 0x3);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x03");

  Read_Data=XGpio_DiscreteRead(&PS2_Conn, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x3)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x3, got 0x%X", Read_Data);
         	Error_Code = 0x010300 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  //change the directions of the pins
  
  //write 10, expect 10
  XGpio_SetDataDirection(&PS2_Conn, 1, 0x2);
  XGpio_DiscreteWrite(&PS2_Conn, 1, 0x2);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x2");

  Read_Data=XGpio_DiscreteRead(&PS2_Conn, 1);
  //xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x2)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x2, got 0x%X", Read_Data);
         	Error_Code = 0x020200 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
  //write 01, expect 11
  XGpio_DiscreteWrite(&PS2_Conn, 1, 0x1);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x1");

  Read_Data=XGpio_DiscreteRead(&PS2_Conn, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x3)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x3, got 0x%X", Read_Data);
         	Error_Code = 0x020300 | (Read_Data & 0x03);
         	return Error_Code;
         }    
  
  //write 00, expect 10
  XGpio_DiscreteWrite(&PS2_Conn, 1, 0x0);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x00");

  Read_Data=XGpio_DiscreteRead(&PS2_Conn, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x2)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x2, got 0x%X", Read_Data);
        	Error_Code = 0x020200 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
  //write 11, expect 11
  XGpio_DiscreteWrite(&PS2_Conn, 1, 0x3);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x03");

  Read_Data=XGpio_DiscreteRead(&PS2_Conn, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x3)) 
         {
            err++;
            if(verbose) xil_printf("\r\nError, expected 0x3, got 0x%X", Read_Data);
        	Error_Code = 0x020300 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
   return XTEST_PASSED;
   
}

Xuint32 PS2_loopback_test(XGpio PS2)
{
 Xuint32 Read_Data=0;
  Xuint32 temp;
  char i, err;

  Xuint32 Error_Code = 0;

  err=0;
  
  //write 01, expect 00
  XGpio_SetDataDirection(&PS2, 1, 0x01);
  XGpio_DiscreteWrite(&PS2, 1, 0x1);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x01");

  Read_Data=XGpio_DiscreteRead(&PS2, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x0)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x0, got 0x%X", Read_Data);
			Error_Code = 0x010000 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
  //write 10, expect 11
  XGpio_DiscreteWrite(&PS2, 1, 0x2);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x2");

  Read_Data=XGpio_DiscreteRead(&PS2, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x3)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x3, got 0x%X", Read_Data);
			Error_Code = 0x010300 | (Read_Data & 0x03);
         	return Error_Code;
         }    
  
  //write 00, expect 00
  XGpio_DiscreteWrite(&PS2, 1, 0x0);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x00");

  Read_Data=XGpio_DiscreteRead(&PS2, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x0)) 
         {
            err++;
           if (verbose) xil_printf("\r\nError, expected 0x0, got 0x%X", Read_Data);
			Error_Code = 0x010000 | (Read_Data & 0x03);
         	return Error_Code; 
         }       
  
  //write 11, expect 11
  XGpio_DiscreteWrite(&PS2, 1, 0x3);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x03");

  Read_Data=XGpio_DiscreteRead(&PS2, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x3)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x3, got 0x%X", Read_Data);
			Error_Code = 0x010300 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  //change the directions of the pins
  
  //write 10, expect 00
  XGpio_SetDataDirection(&PS2, 1, 0x2);
  XGpio_DiscreteWrite(&PS2, 1, 0x2);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x2");

  Read_Data=XGpio_DiscreteRead(&PS2, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x0)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x0, got 0x%X", Read_Data);
			Error_Code = 0x020000 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
  //write 01, expect 11
  XGpio_DiscreteWrite(&PS2, 1, 0x1);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x1");
  
  Read_Data=XGpio_DiscreteRead(&PS2, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x3)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x3, got 0x%X", Read_Data);
			Error_Code = 0x020300 | (Read_Data & 0x03);
         	return Error_Code;
         }    
  
  //write 00, expect 00
  XGpio_DiscreteWrite(&PS2, 1, 0x0);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x00");

  Read_Data=XGpio_DiscreteRead(&PS2, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x0)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x0, got 0x%X", Read_Data);
			Error_Code = 0x020000 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
  
  //write 11, expect 11
  XGpio_DiscreteWrite(&PS2, 1, 0x3);
  usleep (100);
  if (verbose) xil_printf("\r\nWriting to PS2 connector 0x03");

  Read_Data=XGpio_DiscreteRead(&PS2, 1);
  if (verbose) xil_printf("\r\nData read from PS2 0x%X", Read_Data);
  
   if (!(Read_Data==0x3)) 
         {
            err++;
            if (verbose) xil_printf("\r\nError, expected 0x3, got 0x%X", Read_Data);
			Error_Code = 0x020300 | (Read_Data & 0x03);
         	return Error_Code;
         }       
  
	if (!(err)) return XST_SUCCESS;
	else return XST_FAILURE;
}


Xuint32 Dip_push_state_change (XGpio DIP8, XGpio Push7)
{
//returns 1 if the status of a pushbutton or DIP switch was changed
//Xuint32 dip, push;
//uses the push and push_pre static variables for pushbuttons
// and the dip and dip_pre static variables for the DIP switches
Xuint8 i;
Xuint8 dip_xor, push_xor;
Xuint32 count=0;

dip = XGpio_DiscreteRead(&DIP8, 1);
push = XGpio_DiscreteRead(&Push7, 1);

dip_xor = dip ^ dip_pre;
push_xor = push ^ push_pre;

   for (i=0; i<8; i++)
   {
      if ((dip_xor & (1 << i)) && (dip &(1 << i))) gpio_devices [i] =1; //on
      else if ((dip_xor & (1 << i)) && !(dip &(1 << i))) gpio_devices [i] =2;//off
      else if (!(dip_xor & (1 << i))) gpio_devices [i] = 0;
    }
dip_pre=dip;

   for (i=8; i<15; i++)
   {
   if ((push_xor & (1 << (i-8))) && (push &(1 << (i-8)))) gpio_devices [i] =1; //on
   else if ((push_xor & (1 << (i-8))) && !(push &(1 << (i-8)))) gpio_devices [i] =2;//off
   else if (!(push_xor & (1 << i))) gpio_devices [i] = 0;
   }
 
push_pre=push;


if ((dip_xor)||(push_xor)) return 1;

else return 0;
}



void poll_gpio_devices (XGpio DIP8, XGpio Push7, XGpio LED8)
{
Xuint8 i, j, k;
Xuint8 LEDs_Data; // data to send to the LEDs
           
Xuint8 LEDs_temp;


  
if (Dip_push_state_change (DIP8, Push7))
{
   LEDs_Data = dip;
   
   for (i=0; i<8; i++)
   {
   if (gpio_devices[i]==1)
   {
   	 xil_printf ("l%d\n",i);//dip on
   	 switch (i)
      {
      case 0: 
      LCDClear();
	  LCDPrintString ("     SW 0     "," Switched ON  ");
      break;

      case 1: 
      LCDClear();
	  LCDPrintString ("     SW 1     "," Switched ON  ");
      break;

      case 2: 
      LCDClear();
	  LCDPrintString ("     SW 2     "," Switched ON  ");
      break;

      case 3: 
      LCDClear();
	  LCDPrintString ("     SW 3     "," Switched ON  ");
      break;

      case 4: 
      LCDClear();
	  LCDPrintString ("     SW 4     "," Switched ON  ");
      break;

      case 5: 
      LCDClear();
	  LCDPrintString ("     SW 5     "," Switched ON  ");
      break;

      case 6: 
      LCDClear();
	  LCDPrintString ("     SW 6     "," Switched ON  ");
      break;

      case 7: 
      LCDClear();
	  LCDPrintString ("     SW 7     "," Switched ON  ");
      break;
      }
   }
   if (gpio_devices[i]==2)
   { 
   	xil_printf ("k%d\n",i);//dip off
  	 switch (i)
      {
      case 0: 
      LCDClear();
	  LCDPrintString ("     SW 0     "," Switched OFF ");
      break;

      case 1: 
      LCDClear();
	  LCDPrintString ("     SW 1     "," Switched OFF ");
      break;

      case 2: 
      LCDClear();
	  LCDPrintString ("     SW 2     "," Switched OFF ");
      break;

      case 3: 
      LCDClear();
	  LCDPrintString ("     SW 3     "," Switched OFF ");
      break;

      case 4: 
      LCDClear();
	  LCDPrintString ("     SW 4     "," Switched OFF ");
      break;

      case 5: 
      LCDClear();
	  LCDPrintString ("     SW 5     "," Switched OFF ");
      break;

      case 6: 
      LCDClear();
	  LCDPrintString ("     SW 6     "," Switched OFF ");
      break;

      case 7: 
      LCDClear();
	  LCDPrintString ("     SW 7     "," Switched OFF ");
      break;
      }   
   }
   }
   for (i=8; i<15; i++)
   {
   j = i-8;
   
   if (gpio_devices[i]==1)
   { 
   	xil_printf ("p%d\n",i-8);//push button press

	if (j==6) IndividualSetPhyLeds(&Hard_Ethernet_MAC_LlTemac, 0x7F, LED_BLINK);
	else
	{
		IndividualSetPhyLeds(&Hard_Ethernet_MAC_LlTemac, (1<<j), LED_BLINK);
	}
 
      switch (j)
      {
      case 0: 
      LCDClear();
	  LCDPrintString ("CENTER Button ","    Pressed   ");
	  GenSquare (XPAR_AC97_IF_00_0_BASEADDR, BOTH_CHANNELS, 1000, 1000);
      break;

      case 1: 
      LCDClear();
	  LCDPrintString (" LEFT Button  ","    Pressed   ");
	  GenSquare (XPAR_AC97_IF_00_0_BASEADDR, LEFT_CHANNEL, 1000, 1000);
      break;

      case 2: 
      LCDClear();
	  LCDPrintString (" DOWN Button  ","    Pressed   ");
	  GenSquare (XPAR_AC97_IF_00_0_BASEADDR, BOTH_CHANNELS, 500, 1000);
      break;

      case 3: 
      LCDClear();
	  LCDPrintString (" RIGHT Button ","    Pressed   ");
      GenSquare (XPAR_AC97_IF_00_0_BASEADDR, RIGHT_CHANNEL, 1000, 1000);
      break;

      case 4: 
      LCDClear();
	  LCDPrintString ("  UP Button   ","    Pressed   ");
      GenSquare (XPAR_AC97_IF_00_0_BASEADDR, BOTH_CHANNELS, 2000, 1000);
      break;

      case 5: 
      LCDClear();
	  LCDPrintString (" BTN1 Button  ","    Pressed   ");
      GenSquare (XPAR_AC97_IF_00_0_BASEADDR, BOTH_CHANNELS, 5000, 1000);
      break;

      case 6: 
      LCDClear();
	  LCDPrintString (" BTN0 Button  ","    Pressed   ");
	  GenSquare (XPAR_AC97_IF_00_0_BASEADDR, BOTH_CHANNELS, 3000, 1000);
      break;

      }
   }
   if (gpio_devices[i]==2)
   {
   	 xil_printf ("r%d\n",i-8);//push button release
   	  
   	if (j==6) IndividualSetPhyLeds(&Hard_Ethernet_MAC_LlTemac, 0x7F, LED_NORMAL);
	else
	{
   	 IndividualSetPhyLeds(&Hard_Ethernet_MAC_LlTemac, (1<<j), LED_NORMAL);
	}
      switch (j)
      {
      case 0: 
      LCDClear();
	  LCDPrintString ("CENTER Button ","   Released   ");
      break;

      case 1: 
      LCDClear();
	  LCDPrintString (" LEFT Button  ","   Released   ");
      break;

      case 2: 
      LCDClear();
	  LCDPrintString (" DOWN Button  ","   Released   ");
      break;

      case 3: 
      LCDClear();
	  LCDPrintString (" RIGHT Button ","   Released   ");
      break;

      case 4: 
      LCDClear();
	  LCDPrintString ("  UP Button   ","   Released   ");
      break;

      case 5: 
      LCDClear();
	  LCDPrintString (" BTN1 Button  ","   Released   ");
      break;

      case 6: 
      LCDClear();
	  LCDPrintString (" BTN0 Button  ","   Released   ");
      break;

      }  	 
   }

   }

	XGpio_DiscreteWrite(&LED8, 1, LEDs_Data);

/*
	if (push & 0X04) IndividualSetPhyLeds(&Hard_Ethernet_MAC_LlTemac, 0x7F, LED_BLINK);
	else
	{
		for (k=0; k<7; k++)
		{
			if (push & (1<<k)) IndividualSetPhyLeds(&Hard_Ethernet_MAC_LlTemac, (1<<k), LED_BLINK);
			else IndividualSetPhyLeds(&Hard_Ethernet_MAC_LlTemac, (1<<k), LED_NORMAL);
		}	
	}
*/

 }

}



