/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * 
 *
 * This file is a generated sample test application.
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * SDK application project when you run the "Generate Libraries" menu item.
 *
 */


#include <stdio.h>
#include "xparameters.h"
#include "usbkeyboardbin.h"
#include "xenv_standalone.h"
#include "xintc.h"
#include "intc_header.h"
#include "xbasic_types.h"
#include "xgpio.h"
#include "xuartns550_l.h"
#include "sleep.h"
#include "usb_hpi.h"


/******************************************************************************
 * 
 * 	Variable declaration
 * 
 * ***************************************************************************/


static char UpperMap[] = {
    0,  0,  0,  0,'A','B','C','D',
  'E','F','G','H','I','J','K','L',
  'M','N','O','P','Q','R','S','T',
  'U','V','W','X','Y','Z','!','@',
  '#','$','%','^','&','*','(',')',
  '\n',27,'\b','\t',' ','_','+','{',
  '}','|','|',':','"','~','<','>',
  '?'
};

static char LowerMap[] = {
    0,  0,  0,  0,'a','b','c','d',
  'e','f','g','h','i','j','k','l',
  'm','n','o','p','q','r','s','t',
  'u','v','w','x','y','z','1','2',
  '3','4','5','6','7','8','9','0',
  '\n',27,'\b','\t',' ','-','=','[',
  ']','\\','\\',';','\'','`',',','.',
  '/'
};

static int OldLower = 0;

extern unsigned char verbose;

int USB_Test()
{
   Xuint16 Temp;
   int Error_Code = 0;
   int err;
   Xuint32 i;

   err=0;

   Temp = UsbRead(HARDWARE_REVISION);
   if (verbose) xil_printf("\r\nHardware Revision = 0x%X", Temp);
   
   if (!(Temp))
   {
	err++;
	if (verbose)
	{
   		xil_printf("\r\nUSB host and device controller is not present, was not properly reset at power-on,"); 
   		xil_printf("\r\nor firmware was not correctly loaded."); 
   		xil_printf("\r\nPlease press the Reset button and run the USB test again");
   		xil_printf("\r\nto see whether it is a reset, firmware or controller problem");
	}
	Error_Code = 0x01;
	return Error_Code;
   }

   UsbSoftReset();

   if (verbose) xil_printf("\r\nSoft Reset initiated");
   i = 0;
   while (XIo_In16(USB_MAILBOX) != COMM_ACK)
   {
   	  i++;
      usleep(10);
      if (i==3000)
      {
          if (verbose)
          {
    		 xil_printf("\r\nUSB host and device controller was not properly reset at power-on,"); 
   		     xil_printf("\r\nor firmware was not correctly loaded."); 
   		     xil_printf("\r\nPlease press the Reset button and run the USB test again");
   		     xil_printf("\r\nto see whether it is a reset or firmware problem");
             Error_Code = 0x02;
			 return Error_Code;
             break;
          }
      }
   }

   if (verbose) xil_printf("\r\nSoft Reset done");

   //read USB 1 status and force J state
   Temp = UsbRead(USB1_STATUS);

   //clear bits 3, 4
   Temp = Temp & (~USB_PORTA_FORCE);

   //set bit 3
   Temp = Temp | USB_PORTA_FORCE_J ;

   if (verbose) xil_printf("\r\nForcing J state");
   UsbWrite(USB1_STATUS, Temp);


   Temp = UsbRead(USB1_STATUS);
   if (verbose) xil_printf("\r\nUSB 1 Status = 0x%X", Temp);

   //read USB 2 status, disable resistors on port A and force normal operation on port A

   Temp = UsbRead(USB2_STATUS);
   Temp = Temp & (~USB_PORTA_PULLUP);
   Temp = Temp & (~USB_PORTA_FORCE);

   UsbWrite(USB2_STATUS, Temp);
 
   Temp = UsbRead(USB2_STATUS);
   if (verbose) xil_printf("\r\nUSB 2 Status = 0x%X", Temp);

   if ((Temp & USB_PORTA_STATUS)!=USB_PORTA_J_STATE)
   {
      err++;
      if (verbose) xil_printf("\r\nError, Expected J state, got 0x%X", Temp&USB_PORTA_STATUS);
	  Error_Code = 0x03;
	  return Error_Code;
   }

   //read USB 1 status and force K state

   Temp = UsbRead(USB1_STATUS);
   Temp = Temp | USB_PORTA_FORCE_K;
   if (verbose) xil_printf("\r\nForcing K state");

   UsbWrite(USB1_STATUS, Temp);

   Temp = UsbRead(USB1_STATUS);
   if (verbose) xil_printf("\r\nUSB 1 Status = 0x%X", Temp);

   Temp = UsbRead(USB2_STATUS);
   if (verbose) xil_printf("\r\nUSB 2 Status = 0x%X", Temp);

   if ((Temp & USB_PORTA_STATUS)!=USB_PORTA_K_STATE)
   {
      err++;
      if (verbose) xil_printf("\r\nError, Expected K state, got 0x%X", Temp&USB_PORTA_STATUS);
	  Error_Code = 0x04;
  	  return Error_Code;
   }

   return 0;
}




/*****************************************************************************/
/**
*
* This function puts the bin file for USB Keyboard test into the internal memory
* of USB chip through the HPI interface.
*
* @param    UsbBaseAddress is the starting location of the USB internal memory
*           to which this bin file data is written.
*
* @return   None
*
* @note     None
*
******************************************************************************/
void UsbWriteBin(Xuint16 UsbBaseAddress)
{
    Xuint32 Index;
    Xuint16 Temp16;
    Xuint8 char0, char1;

    xil_printf("Loading executable file for USB controller chip.\r\n\r\n");
    XIo_Out16(USB_ADDRESS, UsbBaseAddress);
    for (Index = 0; Index < 0x2E9D; Index+=2)
    {
        Temp16 = 0;
	char0 = KeyboardBin[Index]; 
	char1 = KeyboardBin[Index+1]; 
        Temp16 = (char1 << 8) | char0; 
        XIo_Out16(USB_DATA, Temp16);
      //XIo_Out16(USB_DATA, (KeyboardBin[Index+1] << 8) | KeyboardBin[Index]);
    }
}

/*****************************************************************************/
/**
*
* This function does a software reset of the Cypress CY7C67300 USB controller.
*
* @param    UsbBaseAddress is the starting location of the USB internal memory
*           to which this bin file data is written.
*
* @return   None
*
* @note     None
*
******************************************************************************/
void UsbSoftReset()
{
    XIo_Out16(USB_MAILBOX, COMM_RESET);
}

/*****************************************************************************/
/**
*
* This function sets the program counter of the internal processor of
* Cypress CY7C67300 USB controller and the code starts executing from that
* address.
*
* @param    UsbAddress is the starting location of the bin file data.
*
* @return   None
*
* @note     None
*
******************************************************************************/
void UsbSetPc(Xuint16 UsbAddress)
{
    /*
     * Set COMM_CODE_ADDR to addr
     */
    UsbWrite(COMM_CODE_ADDR, UsbAddress);

    /*
     * Set MailBox to execute command
     */
    XIo_Out16(USB_MAILBOX, COMM_JUMP2CODE);
}

/*****************************************************************************/
/**
* This function reads the Cypress CY7C67300 USB controller's mailbox register
* and outputs the keyboard presses to the UART terminal.
*
* @param    None
*
* @return   None
*
* @note     None
*
******************************************************************************/
void UsbReadMailbox()
{
    Xuint16 Status;
    Xuint16 MailboxData;
    Xuint16 Modifier;


    Status = XIo_In16(USB_STATUS);
	//xil_printf ("\r\nStatus = 0x%X", Status);

    if (Status & 0x001)
    {
        MailboxData = XIo_In16(USB_MAILBOX);
//		xil_printf ("\r\nMailboxData = 0x%X", MailboxData);
        Modifier = MailboxData >> 8;
        MailboxData = MailboxData & 0x00FF;
        if (OldLower != MailboxData)
        {
            if (Modifier & 0x0022)
            {
                if (MailboxData >= 4 && MailboxData <= 56)
                {
                    XUartNs550_SendByte(UART_BASEADDR, UpperMap[MailboxData]);
                }
                if (MailboxData == 40)
                {
                    XUartNs550_SendByte(UART_BASEADDR, '\r');
                }
            }
            else
            {
                if (MailboxData >= 4 && MailboxData <= 56)
                {
                    XUartNs550_SendByte(UART_BASEADDR, LowerMap[MailboxData]);
                }
                if (MailboxData == 40)
                {
                    XUartNs550_SendByte(UART_BASEADDR, '\r');
                }
            }

            OldLower = MailboxData;
        }

    }

}


/*****************************************************************************/
/**
*
* This function writes data to the internal registers of the Cypress
* CY7C67300 USB controller.
*
* @param    Address is the address of the register.
* @param    Data is the data to be written to the register.
*
* @return   None
*
* @note     None
*
******************************************************************************/
void UsbWrite(Xuint16 Address, Xuint16 Data)
{
    XIo_Out16(USB_ADDRESS, Address);
    XIo_Out16(USB_DATA, Data);
}

/*****************************************************************************/
/**
*
* This function reads data from the internal registers of the Cypress
* CY7C67300 USB controller.
*
* @param    Address is the address of the register.
*
* @return   The data read from the specified address
*
* @note     None
*
******************************************************************************/
Xuint16 UsbRead(Xuint16 Address)
{
    XIo_Out16(USB_ADDRESS, Address);
    return XIo_In16(USB_DATA);
}




