/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * 
 *
 * This file is a generated sample test application.
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * SDK application project when you run the "Generate Libraries" menu item.
 *
 */


#include <stdio.h>
#include "xparameters.h"
#include "xenv_standalone.h"
#include "xbasic_types.h"
#include "xgpio.h"
#include "xuartns550_l.h"


#define DESTINATION_ADDR  XPAR_DDR2_SDRAM_MPMC_BASEADDR
#define SOURCE_ADDR XPAR_FLASH_MEM0_BASEADDR + 0x1C0000
#define WORDS_TO_COPY  0x180000

#define PROG_START_ADDR XPAR_DDR2_SDRAM_MPMC_BASEADDR

int (*boot_app) (void);

int main() 
{

Xuint16 Flash_Data;
Xuint32 Current_Addr;

   XCACHE_ENABLE_ICACHE();
   XCACHE_ENABLE_DCACHE();

  /* Initialize RS232_Uart_0 - Set baudrate and number of stop bits */
   XUartNs550_SetBaud(XPAR_RS232_UART_0_BASEADDR, XPAR_XUARTNS550_CLOCK_HZ, 9600);
   XUartNs550_mSetLineControlReg(XPAR_RS232_UART_0_BASEADDR, XUN_LCR_8_DATA_BITS);

  LCDOff();
  LCDClear();
  LCDOn();
  LCDInit();
  LCDPrintString   ("- Copying Data -",
  				    "-  From FLASH  -");


   print("---Bootloader---\n\r");


  xil_printf ("\r\nCopying Data from FLASH to DDR2");
  
  //Setting FLASH memory to read array mode
  XIo_Out16 (XPAR_FLASH_MEM0_BASEADDR, 0xFF);
  for (Current_Addr = 0; Current_Addr<WORDS_TO_COPY; Current_Addr = Current_Addr + 2)
  {
  	Flash_Data = XIo_In16(SOURCE_ADDR + Current_Addr);
  	XIo_Out16(DESTINATION_ADDR + Current_Addr, Flash_Data);
//  	xil_printf("\r\nData copied: 0x%X", Flash_Data);
  }
   
  xil_printf ("\r\nCopied %d bytes from FLASH to DDR2", WORDS_TO_COPY*2); 


  LCDClear();
  LCDPrintString   ("- Booting from -",
  				    "-  DDR2 Memory -");

  xil_printf("\r\nBooting from DDR2...");

   XCACHE_DISABLE_ICACHE();
   XCACHE_DISABLE_DCACHE();


  // function pointer that is set to point to the address of  
  // DESTINATION_ADDR
  boot_app = (int (*) (void)) PROG_START_ADDR;
  // jump to start execution code at the address START_ADDR
  boot_app();


   while (1);
}

